using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Text;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.EventSystems;
using UnityEngine.UI;
using SimpleJSON;
using MeshVR;

namespace Slimy
{
    class ScreenTools: MVRScript
    {
        //public JSONStorableBool CameraChangerUI;
        public JSONStorableString UITextString;
        
        public Atom currentAtom;
        public Atom followAtom;
        public Atom targetAtom;
        
        public JSONStorableBool ResetByShift;
        public JSONStorableBool ResetByEsc;
        public JSONStorableBool R90rotate;
        public JSONStorableBool L90rotate;
        public JSONStorableBool ScreenToggle;
        public JSONStorableBool NumKeyCamChange;
        public JSONStorableBool ArrowKeyCamChange;
        public JSONStorableBool AcceleMoveFlag;
        public JSONStorableBool FollowCamFlag;
        
        private bool myCameraChangerUI = true;
        private bool myResetByShift = false;
        private bool myResetByEsc = true;
        private bool myR90rotate = true;
        private bool myL90rotate = false;
        private bool myScreenToggle = true;
        private bool myRotateFlag = false;
        private bool myNumKeyCamChange = true;
        private bool myArrowKeyCamChange = true;
        
        private bool myAcceleMoveFlag = false;

        private bool myFollowCamFlag = false;
        private bool myFollowCamFlagTemp = false;
        private bool myFollowCamFlagTemp2 = false;
        private bool myFollowCamFlagTemp3 = false;
        
        
        protected UIDynamicButton myButton1;
        protected UIDynamicButton myButton2;
        protected UIDynamicButton myButton3;
        protected UIDynamicButton myButton4;
        protected UIDynamicButton myButton5;
        protected UIDynamicButton myButton6;
        protected UIDynamicButton myButton7;
        protected UIDynamicButton myButton8;
        protected UIDynamicButton myButton9;
        protected UIDynamicButton myButton10;
        protected UIDynamicButton myButton11;
        protected UIDynamicButton myButton12;
        protected float sliderValue1;
        protected float sliderValue2;
        protected float sliderValue3;
        protected float sliderValue4;
        protected float sliderValue5;
        protected float sliderValue6;
        protected float sliderValue7;

        protected JSONStorableString helpText1;
        protected JSONStorableString helpText2;
        protected JSONStorableString helpText3;
        protected JSONStorableString helpText4;

        protected JSONStorableFloat jsonFloat_FOV;
        protected JSONStorableFloat jsonFloat_cameraZoffset;

        protected JSONStorableFloat jsonFloat_WorkWindowSize;
        protected JSONStorableFloat jsonFloat_rotationOffset;
        protected JSONStorableFloat jsonFloat_orbitSpeed;
        protected JSONStorableFloat jsonFloat_leapDuration;
        //protected JSONStorableFloat jsonFloat_zoomStep;
        protected JSONStorableFloat jsonFloat_followSmooth;
        
        protected float cameraFOV; 
        protected float cameraZoffset;
         
        private int myMonitorWidth;
        private int myMonitorHeight;
        private string myDisplay;
        private int myAreaWidth;
        private int myAreaHeight;
        private int myWorkWindowSize;
        
        private Quaternion myRot;
        private Quaternion rot;
        private Vector3 _Rotation;
        private Vector3 delta_Rotation;
        private Vector3 localAngle;

        private Transform myTransform;
        private Transform currentTransform;


        public static float currentRot;
        private float currentFOV;
        private float currentPOI;
        private float distancePOI;
        
        private SuperController sc = SuperController.singleton;

/////////////////////////////////////////////////////////////////////////////////////////////////////////

        public Canvas myCanvas;
        private ClickListener clickListener;

        private float offsetH;
        private float offsetV;
        private float imageH;
        private float imageV;

        public GameObject cameraUIgo;
        public GameObject UIgo;
        public Vector3 cameraUIPos;
        
        private float oldHeight;
        private bool UIflag = false;
        public static Image[] myImage = new Image[33];
        
        
        protected string[] saveDatas = new string[12];
        protected bool[] saveFlag = new bool[12];
        

        protected Vector3[] camRotates = new Vector3[12];
        protected Vector3[] camRigPosis = new Vector3[12];
        protected Vector3[] camRigRotates = new Vector3[12];
        
        protected Vector3[] keepCamRotates = new Vector3[12];
        protected Vector3[] keepCamRigPosis = new Vector3[12];
        protected Vector3[] keepCamRigRotates = new Vector3[12];
        
        protected float[] camFOVs = new float[12];
        protected float[] camPOIs = new float[12];
        protected float[] camHeights = new float[12];
        protected float[] currentRots = new float[12];
        
        protected float[] keepCamFOVs = new float[12];
        protected float[] keepCamPOIs = new float[12];

        protected float[] distancePOIs = new float[12];
        
        protected float[] orbitSpeeds = new float[12];
        protected Vector3[] orbitCenterPosis = new Vector3[12];
        
        protected float[] leapDurations = new float[12];
        
        protected bool[] AcceleMoveFlags = new bool[12];
        
        protected bool[] FollowCamFlags = new bool[12];
        protected string[] FollowTargetAtoms = new string[12];
        protected string[] FollowTargetControls = new string[12];
        protected float[] FollowSensitives = new float[12];
        
        public static Transform myCameraRig;
        public static Transform myCamera;
        private int currentCameraNo = 0;
        
        public Texture2D tex2dSave;//saveIcon
        public Texture2D tex2dDel;//delIcon
        public Texture2D tex2dHide;//hideIcon
        public Texture2D tex2dCamera;//cameraIcon
        public Texture2D tex2dBack;//backIcon
        public Texture2D tex2dNext;//nextIcon
        public Texture2D tex2dReset;//resetIcon
      
        protected JSONStorableBool CameraChangerUI = new JSONStorableBool("CameraChangerUI", false);
        
        private float followSensitive = 3.0f;
        protected JSONStorableStringChooser atomJSON;
        protected JSONStorableStringChooser receiverJSON;
        protected UIDynamicPopup dp;
        protected Atom receivingAtom;

//////////////NEW ORBIATAL Rotate///////////////////////////////////////////////// 
  
public GameObject myScreenCenterEmpty;
public Transform myCameraTransform = SuperController.singleton.MonitorCenterCamera.transform;
public Transform myCameraRigTransform = SuperController.singleton.MonitorCenterCamera.transform.parent.parent;
public bool autoRotateFlag;

public Transform myKeepRigTransform;
public Transform myKeepCameraTransform;

public Vector3 keepMyFoward;
public float keepCurrentRot;
public Vector3 keepWorld_posi;

public float orbitSpeed;

private Transform target;
public Vector3 offsetTarget;

//private float time;
private float leapDuration =0f;

private IEnumerator activeCoroutine;

private List<string> targetChoices;



/////////////////////////////////////////////////////////////////////////////////////////////////////
    private static class Utils //MacGruber Utils
    {
        //Overrides for the 3 methods below.
                public static string PluginPathOverride = null;
                public static string PackagePathOverride = null;
                public static bool? IsInPackageOverride = null;

        //Get directory path where the plugin is located. Based on Alazi's & VAMDeluxe's method.


                public static string GetPluginPath(MVRScript self)
                {
                        if (PluginPathOverride != null)
                        return PluginPathOverride;

                        string id = self.name.Substring(0, self.name.IndexOf('_'));
                        string filename = self.manager.GetJSON()["plugins"][id].Value;
                        return filename.Substring(0, filename.LastIndexOfAny(new char[] { '/', '\\' }));
                }
    }
/////////////////////////////////////////////////////////////////////////////////////////////////////
    private void loadCameraDataFromUIText()
    {
//SuperController.LogMessage("loadCameraDataFromUIText start");

     for(int i = 1; i < 11; i++)
     {
         myImage[i+10].color = new Color(0.3f, 0.3f, 0.3f);
     }

          Array.Clear(camRotates, 0, camRotates.Length);
          Array.Clear(camRigPosis, 0, camRigPosis.Length);
          Array.Clear(camRigRotates, 0, camRigRotates.Length);
          Array.Clear(camHeights, 0, camHeights.Length);
          Array.Clear(camFOVs, 0, camFOVs.Length);
          Array.Clear(camPOIs, 0, camPOIs.Length);
          Array.Clear(currentRots, 0, currentRots.Length);
          Array.Clear(keepCamFOVs, 0, keepCamFOVs.Length);
          Array.Clear(keepCamPOIs, 0, keepCamPOIs.Length);
          Array.Clear(saveFlag, 0, saveFlag.Length);
          Array.Clear(orbitSpeeds, 0, orbitSpeeds.Length);
          Array.Clear(orbitCenterPosis, 0, orbitCenterPosis.Length);
          Array.Clear(keepCamRotates, 0, keepCamRotates.Length);
          Array.Clear(keepCamRigPosis, 0, keepCamRigPosis.Length);
          Array.Clear(keepCamRigRotates, 0, keepCamRigRotates.Length);
          Array.Clear(leapDurations, 0, leapDurations.Length);
          Array.Clear(AcceleMoveFlags, 0, AcceleMoveFlags.Length);
          
          Array.Clear(FollowCamFlags, 0, FollowCamFlags.Length);
          Array.Clear(FollowTargetAtoms, 0, FollowTargetAtoms.Length);
          Array.Clear(FollowTargetControls, 0, FollowTargetControls.Length);
          Array.Clear(FollowSensitives, 0, FollowSensitives.Length);
          

         currentAtom = SuperController.singleton.GetAtomByUid("CameraChanger_UIText_temp");
         UITextString = currentAtom.GetStorableByID("Text").GetStringJSONParam("text");
         string saveDataString = UITextString.val;
 
         string str1 = saveDataString.Replace("(", "");
         string str2 = str1.Replace(")", "");
         string str3 = str2.Replace(" ", "");
         
         string[] saveDatas =  str3.Split('\n');

        for (int i = 1; i < 11; i++) {
        string[] saveItems =  saveDatas[i].Split('!');

int arrayCount = saveItems.Length;
//SuperController.LogMessage("saveItems.Length =" + arrayCount);
 
 
        //SuperController.LogMessage("saveItems[1] =" + saveItems[1]);
           camRotates[i]= StringToVector3(saveItems[1]);
        //SuperController.LogMessage("saveItems[2] =" + saveItems[2]);
           camRigPosis[i]= StringToVector3(saveItems[2]);
        //SuperController.LogMessage("saveItems[3] =" + saveItems[3]);
           camRigRotates[i]= StringToVector3(saveItems[3]);
        //SuperController.LogMessage("saveItems[4] =" + saveItems[4]);
           camHeights[i]= float.Parse(saveItems[4]);
        //SuperController.LogMessage("saveItems[5] =" + saveItems[5]);
           camFOVs[i]= float.Parse(saveItems[5]);
        //SuperController.LogMessage("saveItems[6] =" + saveItems[6]);
           camPOIs[i]= float.Parse(saveItems[6]);
        //SuperController.LogMessage("saveItems[7] =" + saveItems[7]);
           currentRots[i]= float.Parse(saveItems[7]);
        //SuperController.LogMessage("saveItems[8] =" + saveItems[8]);
           keepCamFOVs[i]= float.Parse(saveItems[8]);
        //SuperController.LogMessage("saveItems[9] =" + saveItems[9]);
           keepCamPOIs[i]= float.Parse(saveItems[9]);
        //SuperController.LogMessage("saveItems[10] =" + saveItems[10]);
           saveFlag[i]= Convert.ToBoolean(saveItems[10]);
        //SuperController.LogMessage("saveItems[11] =" + saveItems[11]);
           orbitSpeeds[i]= float.Parse(saveItems[11]);
        //SuperController.LogMessage("saveItems[12] =" + saveItems[12]);
           orbitCenterPosis[i]= StringToVector3(saveItems[12]);
        //SuperController.LogMessage("saveItems[13] =" + saveItems[13]);
           keepCamRotates[i]= StringToVector3(saveItems[13]);
        //SuperController.LogMessage("saveItems[14] =" + saveItems[14]);
           keepCamRigPosis[i]= StringToVector3(saveItems[14]);
           
           
           
           if (arrayCount < 16)
           {
              //SuperController.LogMessage("saveItems.Length < 16" ); 
              keepCamRigRotates[i]= StringToVector3("0,0,0");
           } else {
              //SuperController.LogMessage("saveItems[15] =" + saveItems[15]);
              keepCamRigRotates[i]= StringToVector3(saveItems[15]);
           }
           
           if (arrayCount < 17)
           {
              //SuperController.LogMessage("saveItems.Length < 17" ); 
              leapDurations[i]= 0f;
           } else {
              leapDurations[i]= float.Parse(saveItems[16]);
           }
           
           if ((arrayCount < 18)||(saveItems[17] == "0"))
           {
              //SuperController.LogMessage("saveItems.Length < 18" ); 
              AcceleMoveFlags[i]= false;
           } else {
              AcceleMoveFlags[i]= Convert.ToBoolean(saveItems[17]);

           }
           
           if ((arrayCount < 19)||(saveItems[18] == "0"))
           {
              //SuperController.LogMessage("saveItems.Length or format ERROR" ); 
              FollowCamFlags[i] = false;
           } else {
              FollowCamFlags[i]= Convert.ToBoolean(saveItems[18]);

           }
           
           if ((arrayCount < 20)||(saveItems[19] == "0"))
           {
              //SuperController.LogMessage("saveItems.Length or format ERROR" ); 
              FollowTargetAtoms[i] = "None";
           } else {
              FollowTargetAtoms[i]= saveItems[19];

           }


           if ((arrayCount < 21)||(saveItems[20] == "0"))
           {
              //SuperController.LogMessage("saveItems.Length or format ERROR" ); 
              FollowTargetControls[i] = "None";
           } else {
              FollowTargetControls[i]= saveItems[20];

           }


           if ((arrayCount < 22)||(saveItems[21] == "0"))
           {
              //SuperController.LogMessage("saveItems.Length or format ERROR" ); 
              FollowSensitives[i] = 3f;
           } else {
              FollowSensitives[i]= float.Parse(saveItems[21]);

           }

          //SuperController.LogMessage("No "+i+" OK"); 
        }

/* MEMO  
         cameraNo
         camRotates[i] vec3
         camRigPosis[i] vec3
         camRigRotates[i] vec3
         camHeights[i] float
         camFOVs[i] float
         camPOIs[i] float
         currentRots[i] float
         keepCamFOVs[i] float
         keepCamPOIs[i] float
         saveFlag[i] bool
         orbitSpeeds[i] float   [11]
         orbitCenterPosis[i] vec3   [12]
         keepCamRotates[i] vec3   [13]
         keepCamRigPosis[i] vec3   [14]
         keepCamRigRotates[i] vec3   [15]
         leapDurations[i]  float [16]
         AcceleMoveFlags[i]  float [17]
         
         FollowCamFlags [18]
         FollowTargetAtoms  [19]
         FollowTargetControls  [20]
         FollowSensitives  [21]
         extra 0,0,0,0
*/

     
     ResetCameraIcon();

    //SuperController.LogMessage("loadCameraDataFromUIText END");


    }
/////////////////////////////////////////////////////////////////////////////////////////////////////
    void OnBeforeSceneSave()
    {
       buttonClickA();//if saved scene with 90rotated, fatal problem when opened it again
    }
/////////////////////////////////////////////////////////////////////////////////////////////////////
    void OnSceneLoaded()
    {
        //SuperController.LogMessage("OnSceneLoaded");
        createTempAtom();
        
        loadCameraDataFromUIText();

         
    }
///////////////////////////////////////////////////////////////////////////    
    void OnDestroy()
    {
        SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;
        SuperController.singleton.onBeforeSceneSaveHandlers -= OnBeforeSceneSave;
        
        buttonClickA();//if saved scene with 90rotated, fatal problem when opened it again

    }
    
///////////////////////////////////////////////////////////////////////////     
     
   
/////////////////////////////////////////////////////////////////////////////////////////////////////////
    public override void Init() //
    {
        SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;
        SuperController.singleton.onBeforeSceneSaveHandlers += OnBeforeSceneSave;

//SuperController.LogMessage("INIT(Plugin Reloaded)");


        EnableTumble();//////////RightClick LOCK to free

        createTempAtom();

        RegisterBool(CameraChangerUI);

        myMonitorWidth = Screen.currentResolution.width;
        myMonitorHeight = Screen.currentResolution.height;
        myDisplay = Screen.currentResolution.ToString();
        myAreaWidth = Screen.width;
        myAreaHeight = Screen.height;
        
        myTransform = sc.MonitorCenterCamera.transform;
        pluginLabelJSON.val = "Slimy_ScreenTools";

        JSONStorableString helpText2 = new JSONStorableString("About", 
        "<color=#099><b><size=60>ScreenTools</size><size=45> ver.8</size></b></color>\n" +
        "Slimy 16-May-2024");
        UIDynamic helpTextfield2 = CreateTextField(helpText2, false);
        helpTextfield2.height = 110.0f;

        //Enable cameraChangerUI/////////////////////////////////////////////////////////////////////////

            CameraChangerUI = new JSONStorableBool("<color=#900><size=30><b>Enable Camera Changer UI</b></size></color>", true, CameraChangerUICallback);
            CameraChangerUI.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(CameraChangerUI,false);
            RegisterBool(CameraChangerUI);
            
            helpText3 = new JSONStorableString("", "<color=#900><size=28>ver3.0 Feature [Camera Changer]\nSave/Restore 10 Camera Positions.</size></color>" );
            UIDynamic helpTextfield3 = CreateTextField(helpText3, false);
            helpTextfield3.height =100f;

        //ResetByEsc/////////////////////////////////////////////////////////////////////////
            ResetByEsc = new JSONStorableBool("RESET Rotate by [ESC] key", true, ResetByEscCallback);
            ResetByEsc.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(ResetByEsc,false);
            RegisterBool(ResetByEsc);
            
        //ResetByShift/////////////////////////////////////////////////////////////////////////
            ResetByShift = new JSONStorableBool("RESET Rotate by [SHIFT] Key", false, ResetByShiftCallback);
            ResetByShift.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(ResetByShift,false);
            RegisterBool(ResetByShift);
            
        //NumKeyCamChange/////////////////////////////////////////////////////////////////////////
            NumKeyCamChange = new JSONStorableBool("Camera Change by [0-9] Key", true, NumKeyCamChangeCallback);
            NumKeyCamChange.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(NumKeyCamChange,false);
            RegisterBool(NumKeyCamChange);
            
        //ArrowKeyCamChange/////////////////////////////////////////////////////////////////////////
            ArrowKeyCamChange = new JSONStorableBool("Camera Change by [arrow L&R] Key", true, ArrowKeyCamChangeCallback);
            ArrowKeyCamChange.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(ArrowKeyCamChange,false);
            RegisterBool(ArrowKeyCamChange);   
            

        //RESET button UI/////////////////////////////////////////////////////////////////////////
            myButton1 = CreateButton("<size=40><color=red><b>RESET Rotate</b></color></size>", false);
            myButton1.height = 70;
            myButton1.button.onClick.AddListener(buttonClickA);
            RegisterAction(new JSONStorableAction("RESET Rotate", () => {
                buttonClickA();
            }));

         //FOV slider/////////////////////////////////////////////////////////////////////////
            var FOVslider = sc.monitorCameraFOVSlider;
            jsonFloat_FOV = new JSONStorableFloat("FoV adjust", 40f, 20.0f, 100f)
            {
            isStorable = false,
            valNoCallback = FOVslider.value,
            setCallbackFunction = val =>
            {
                FOVslider.value = val;
            }
            };
            RegisterFloat(jsonFloat_FOV);
            var slider1 = CreateSlider(jsonFloat_FOV, false);
            slider1.valueFormat = "F0";

         //button2 UI///////////////////////////////////////////////////////////////////////////
         /*   myButton2 = CreateButton("<size=35><color=#091><b>Right90 Rotate</b></color></size>", false);
            myButton2.height = 60;
            myButton2.button.onClick.AddListener(buttonClickC);
            RegisterAction(new JSONStorableAction("Right90 TURN Button", () => {
                buttonClickC();
            }));
         */
         //button3 UI///////////////////////////////////////////////////////////////////////////
            myButton3 = CreateButton("<size=40><color=#091><b>>>> Right90 FoV FIT <<</b></color></size>", false);
            myButton3.height = 60;
            myButton3.button.onClick.AddListener(buttonClickD);
            RegisterAction(new JSONStorableAction("Right90 FoV FIT", () => {

            buttonClickD();

            }));
            
          //Rotation Offset slider/////////////////////////////////////////////////////////////////////////
            jsonFloat_rotationOffset = new JSONStorableFloat("CustomRotateAngle", 90f, -180f, 180f,true,true);
            RegisterFloat(jsonFloat_rotationOffset);
            var slider3 = CreateSlider(jsonFloat_rotationOffset, false);
            slider3.valueFormat = "F1";
            sliderValue3 = jsonFloat_rotationOffset.val; 
            
            
         //Shortcut ctrl+R/////////////////////////////////////////////////////////////////////////
            R90rotate = new JSONStorableBool("R90rotate by [Ctrl+R] Key", myR90rotate, R90rotateCallback);
            R90rotate.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(R90rotate,false);
            RegisterBool(R90rotate);

         //button4 UI///////////////////////////////////////////////////////////////////////////
         /*   myButton4 = CreateButton("<size=35><color=#078><b>Left90 Rotate</b></color></size>", false);
            myButton4.height = 60;
            myButton4.button.onClick.AddListener(buttonClickB);
            RegisterAction(new JSONStorableAction("Left90 TURN Button", () => {
                buttonClickB();
            }));
          */
         //button7 UI///////////////////////////////////////////////////////////////////////////
            myButton7 = CreateButton("<size=40><color=#078><b>>>> Left90 FoV FIT <<<</b></color></size>", false);
            myButton7.height = 60;
            myButton7.button.onClick.AddListener(buttonClickG);
            RegisterAction(new JSONStorableAction("Left90 FoV FIT", () => {
                buttonClickG();
            }));
            
         //Shortcut ctrl+L/////////////////////////////////////////////////////////////////////////
            L90rotate = new JSONStorableBool("L90rotate by [Ctrl+L] Key", myL90rotate, L90rotateCallback);
            L90rotate.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(L90rotate,false);
            RegisterBool(L90rotate);
            
            //Rescan();

            //ResetUI();
            
         //Monitor Info///////////////////////////////////////////////////////////////////////////
            helpText1 = new JSONStorableString("About", 
            "<color=#055><size=35>Display Resolution</size></color>\n" +
            "<size=40>  "+ myDisplay +"</size>\n" +
        
            "<color=#055><size=35>Current VaM area</size></color>\n" +
            "<size=40>  "+ myAreaWidth +" x " + myAreaHeight +"</size>"
            );

            UIDynamic helpTextfield1 = CreateTextField(helpText1, true);
            helpTextfield1.height =180.0f;

          //Reflesh Info Button11_UI///////////////////////////////////////////////////////////////////////////
            myButton11 = CreateButton("Reflesh Info", true);
            myButton11.height = 50;
            myButton11.button.onClick.AddListener(RefleshInfo);

          //button5 UI///////////////////////////////////////////////////////////////////////////
            myButton5 = CreateButton("<color=#B30><b><size=35>FULLScreen\n"+ myMonitorWidth +" x "+ myMonitorHeight + "px</size></b></color>", true);
            myButton5.height = 80;
            myButton5.button.onClick.AddListener(buttonClickE);
            RegisterAction(new JSONStorableAction("FULLScreen Button", () => {
                buttonClickE();
            }));

          //button6 UI///////////////////////////////////////////////////////////////////////////
            myButton6 = CreateButton("<color=#B30><b><size=35>FULLScreen\n(Gap for Taskbar)</size></b></color>", true);
            myButton6.height = 80;
            myButton6.button.onClick.AddListener(buttonClickF);
            RegisterAction(new JSONStorableAction("FULLScreen(Gap)Button", () => {
                buttonClickF();
            }));

          //button8 UI///////////////////////////////////////////////////////////////////////////
            myButton8 = CreateButton("<color=#038><b><size=35>Windowed\n(Gap for Taskbar)</size></b></color>", true);
            myButton8.height = 80;
            myButton8.button.onClick.AddListener(buttonClickH);
            RegisterAction(new JSONStorableAction("Windowed(Gap)Button", () => {
                buttonClickH();

            }));
            
          //Window Shrink slider/////////////////////////////////////////////////////////////////////////
            jsonFloat_WorkWindowSize = new JSONStorableFloat("Window Shrink Width(%)", 50f, 10f, 100f,true,true);
            RegisterFloat(jsonFloat_WorkWindowSize);
            var slider2 = CreateSlider(jsonFloat_WorkWindowSize, true);
            slider2.valueFormat = "F0";
            sliderValue2 = jsonFloat_WorkWindowSize.val;
            
          //ScreenToggle/////////////////////////////////////////////////////////////////////////
            ScreenToggle = new JSONStorableBool("FullScreen Toggle [Ctrl+Enter] Key", myScreenToggle, ScreenToggleCallback);
            ScreenToggle.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(ScreenToggle,true);
            RegisterBool(ScreenToggle);
            


          //button9 ORBIT rotate UI///////////////////////////////////////////////////////////////////////////
            myButton9 = CreateButton("<color=#038><b><size=40>Orbital Rotate</size></b></color>", true);
            myButton9.height = 50;
            myButton9.button.onClick.AddListener(buttonClickI);
            RegisterAction(new JSONStorableAction("Orbital Rotate ON/OFF", () => {

                buttonClickI();

            }));

          //OrbitSpeed slider/////////////////////////////////////////////////////////////////////////
            jsonFloat_orbitSpeed = new JSONStorableFloat("OrbitSpeed (-L<<>>+R)", 0.3f, -3.0f, 3.0f,true,true);
            RegisterFloat(jsonFloat_orbitSpeed);
            var slider4 = CreateSlider(jsonFloat_orbitSpeed, true);
            slider4.valueFormat = "F1";
            sliderValue4 = jsonFloat_orbitSpeed.val; 
            
          //leapDuration slider/////////////////////////////////////////////////////////////////////////
            jsonFloat_leapDuration = new JSONStorableFloat("Transition Duration(s)", 1f, 0f, 8f,false,true);
            RegisterFloat(jsonFloat_leapDuration);
            var slider5 = CreateSlider(jsonFloat_leapDuration,true);
            slider5.valueFormat = "F1";
            sliderValue5 = jsonFloat_leapDuration.val;
            
            //AcceleMove On/Off/////////////////////////////////////////////////////////////////////////
            AcceleMoveFlag = new JSONStorableBool("AcceleMove Enable", myAcceleMoveFlag, AcceleMoveFlagCallback);
            AcceleMoveFlag.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(AcceleMoveFlag,true);
            RegisterBool(AcceleMoveFlag);
            
            
            
            //followList PULLDOWN///////////////////////////////////

            List<string> targetChoices = new List<string>();
            //targetChoices.Add("None");//dammyData
            var atoms = SuperController.singleton.GetAtoms();
            foreach(var atom in atoms)
            {
                 //SuperController.LogMessage("atom =" + atom.name);
                 if((atom.type == "Person")||(atom.type == "Empty"))
                 {
                    //targetChoices.Add(atom.type);
                    targetChoices.Add(atom.name);
                 }
            }

            atomJSON = new JSONStorableStringChooser("follow Atom", targetChoices, "None", "<color=#830>follow Person</color>", SyncAtom);
            RegisterStringChooser(atomJSON);
            dp = CreateScrollablePopup(atomJSON, true);
            dp.popupPanelHeight = 300f;

       
            receiverJSON = new JSONStorableStringChooser("follow Control",null, "None", "<color=#830>follow Control</color>",SyncControl);
            dp = CreateScrollablePopup(receiverJSON, true);
            dp.popupPanelHeight = 700f;

            ////////////////////////////////////////////////////////////////////////////////////////////

            
            //Reflesh Info Button12_UI///////////////////////////////////////////////////////////////////////////
            myButton12 = CreateButton("<color=#830>Refresh Atom List</color>", true);
            myButton12.height = 50;
            myButton12.button.onClick.AddListener(RefleshAtomList);
            

            //followSmooth slider/////////////////////////////////////////////////////////////////////////
            jsonFloat_followSmooth = new JSONStorableFloat("<color=#830>follow Sensitivity</color>", 3f, 0f, 10f,false,true);
            RegisterFloat(jsonFloat_followSmooth);
            var slider7 = CreateSlider(jsonFloat_followSmooth,true);
            slider7.valueFormat = "F1";
            sliderValue7 = jsonFloat_followSmooth.val;
            
            
            ///////////////////////////////////////////////////////////////////////////////////////////
            //followCamera On/Off/////////////////////////////////////////////////////////////////////////
            FollowCamFlag = new JSONStorableBool("<color=#830><b><size=30>followCamera Enable</size></b></color>", myFollowCamFlag, FollowCamFlagCallback);
            FollowCamFlag.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(FollowCamFlag,true);
            RegisterBool(FollowCamFlag);
            

            
            //ver8 Feature HELP text/////////////////////////////////////////////////////////////////////////
            helpText4 = new JSONStorableString("", "<color=#900><size=30><b>ver.8 Feature [follow Camera]</b>\nThis is an experimental feature.\nIt may have a negative effect on FPS.\nThe camera tracks the target.\nPrevents Person from moving too far and going out of frame.\nSelect the target to track from the pulldown and check Enable to start tracking.\nThis setting is saved to the individual camera button information.\nYou can choose Person parts or Empty as target.\nIf you already have an animated Empty for Camride, you can use it.</size></color>" );
            UIDynamic helpTextfield4 = CreateTextField(helpText4, true);
            helpTextfield4.height =600f;
            

       //Camera Trigger/////////////////////NOT WORKS when SessionPlugin

            RegisterAction(new JSONStorableAction("Camera1", () => {
                PointerClick_cameraIcon(1);
            }));
            
            RegisterAction(new JSONStorableAction("Camera2", () => {
                PointerClick_cameraIcon(2);
            }));
            
            RegisterAction(new JSONStorableAction("Camera3", () => {
                PointerClick_cameraIcon(3);
            }));
            
            RegisterAction(new JSONStorableAction("Camera4", () => {
                PointerClick_cameraIcon(4);
            }));
            
            RegisterAction(new JSONStorableAction("Camera5", () => {
                PointerClick_cameraIcon(5);
            }));
            
            RegisterAction(new JSONStorableAction("Camera6", () => {
                PointerClick_cameraIcon(6);
            }));
            
            RegisterAction(new JSONStorableAction("Camera7", () => {
                PointerClick_cameraIcon(7);
            }));
            
            RegisterAction(new JSONStorableAction("Camera8", () => {
                PointerClick_cameraIcon(8);
            }));
            
            RegisterAction(new JSONStorableAction("Camera9", () => {
                PointerClick_cameraIcon(9);
            }));
            
            RegisterAction(new JSONStorableAction("Camera10", () => {
                PointerClick_cameraIcon(10);
            }));
            
         /////////////////
            RegisterAction(new JSONStorableAction("Next Camera", () => {
                NextCamera();
            }));
            
            RegisterAction(new JSONStorableAction("Previous Camera", () => {
                BeforeCamera();
            }));
          /////////////////
            
            
            

        }
/////////////////////////////////////////////////////////////////////////////////////////////////////////
    private void CreateCameraChangerUI()
         {

           currentCameraNo = 0;

         //create CANVAS
                if (myCanvas != null)
                return;

            GameObject canvasObject = new GameObject();
            myCanvas = canvasObject.AddComponent<Canvas>();

            //myCanvas.renderMode = RenderMode.WorldSpace;
            //myCanvas.renderMode = RenderMode.ScreenSpaceCamera;
            myCanvas.renderMode = RenderMode.ScreenSpaceOverlay;
            
            myCanvas.pixelPerfect = false;
            SuperController.singleton.AddCanvas(myCanvas);

            GraphicRaycaster gr = canvasObject.AddComponent<GraphicRaycaster>(); // click enable

            float scale = 0.005f * SuperController.singleton.worldScale;

            myCanvas.transform.localScale = new Vector3(scale, scale, scale);
            myCanvas.transform.localPosition = new Vector3(0, 0, 0);
            myCanvas.transform.localEulerAngles = new Vector3(0, 0, 0); // look at camera

            myCanvas.transform.Translate(0f, 0f, -0f);

        CreateUI();
        
        oldHeight = Screen.height;
        
        }
/////////////////////////////////////////////////////////////////////////////////////////////////////////
    private void createTempAtom(){
                  //Create "Atom" UIText//////////////////////////////////////////////////////
                  var uids = new HashSet<string>(SuperController.singleton.GetAtomUIDs());
    
                       if(!uids.Contains("CameraChanger_UIText_temp"))  //not yet exists
                       {
                           //SuperController.LogMessage("Not Yet exists. create UIText Atom ");
                           
                           StartCoroutine(CreateAtomCo("UIText", "CameraChanger_UIText_temp", atom => {
                           // atom reference available here
                           
                           currentAtom = SuperController.singleton.GetAtomByUid("CameraChanger_UIText_temp");
                           UITextString = currentAtom.GetStorableByID("Text").GetStringJSONParam("text");
                           currentAtom.hidden = true;
                           currentAtom.SetOn(false);
                           //UITextString.val = "sample";

                           Invoke("AfterCreateTempAtom", 0f);
                           
                           }));
                       
                       }
                       else //already exists
                       {
                           //SuperController.LogMessage("already exists. use currentAtom");

                           currentAtom = SuperController.singleton.GetAtomByUid("CameraChanger_UIText_temp");
                           UITextString = currentAtom.GetStorableByID("Text").GetStringJSONParam("text");
                           currentAtom.hidden = true;
                           currentAtom.SetOn(false);

                           Invoke("AfterCreateTempAtom", 0f);
                           
                       }
                    }
/////////////////////////////////////////////////////////////////
    private void AfterCreateTempAtom(){


	//loadCameraDataFromUIText();


       //UITextString.val = "";
        
        ArrayDataToUIText();
        
        //Fake load UIText data
        saveCamera(0);
        
        
        //Update();
        

    }
///////////////////////////////////////////////////////////////////////////
    private void EnableCameraChangerUI(){

                  CreateUI();
                  oldHeight = Screen.height;

                  
    }
            
///////////////////////////////////////////////////////////////////////////
    private void DisableCameraChangerUI(){

           Destroy(cameraUIgo);
           Destroy(UIgo);

    }

//ReSCAN current Resolution////////////////////////////////////////////////////
    public void Rescan(){
        
        int newMonitorWidth = Screen.currentResolution.width;
        int newMonitorHeight = Screen.currentResolution.height;

           if (newMonitorWidth > myMonitorWidth){
             myMonitorWidth = newMonitorWidth;
             myDisplay = Screen.currentResolution.ToString();
           }
        
           if (newMonitorHeight > myMonitorHeight){
             myMonitorHeight = newMonitorHeight;
            myDisplay = Screen.currentResolution.ToString();
           }

        myAreaWidth = Screen.width;
        myAreaHeight = Screen.height;

    }


//RESET UI////////////////////////////////////////////////////
     public void ResetUI(){

            myButton5.label = "<color=#B30><b><size=35>FULLScreen\n"+ myMonitorWidth +" x "+ myMonitorHeight + "px</size></b></color>";
            
            helpText1.val = ("<color=#055><size=35>Display Resolution</size></color>\n" +
            "<size=40>  "+ myDisplay +"</size>\n" +
            "<color=#055><size=35>Current VaM area</size></color>\n" +
            "<size=40>  "+ myAreaWidth +" x " + myAreaHeight +"</size>"
            );
            
            
            
            

            
            

            
            
     }

////////////////////////////////////////////////////
//BUTTON Orbital ROTATE
        public void buttonClickI()
        {



        if (myScreenCenterEmpty != null){
	//SuperController.LogMessage("myScreenCenterEmpty already EXISTS");
	//autoRotateFlag = false;
	Destroy(myScreenCenterEmpty);
	//return;
	}

   if (autoRotateFlag == true){


       myImage[26].color = new Color(1f, 1f, 1f);
        myImage[27].color = new Color(1f, 1f, 1f);

        autoRotateFlag = false;
        Destroy(myScreenCenterEmpty);
        
   } else if(autoRotateFlag == false){

       if  (jsonFloat_orbitSpeed.val >0)
       {
        myImage[26].color = new Color(1f, 0.2f, 0.5f);
        } else {
        myImage[27].color = new Color(1f, 0.2f, 0.5f);
        }
        
        
        myScreenCenterEmpty = new GameObject("EMPTY");

        myScreenCenterEmpty.SetActive(true);

        Vector3 myAreaCenter = new Vector3(Screen.width/2 , Screen.height/2 , sc.focusDistance);
        Vector3 world_posi = Camera.main.ScreenToWorldPoint(myAreaCenter);
        myScreenCenterEmpty.transform.position = world_posi;


        autoRotateFlag = true;

}

        }
////////////////////////////////////////////////////
//BUTTON10 (TEST)
        public void buttonClickJ()//TESTSCRIPT
        {

//keepWorld_posi
//keepMyFoward
//keepCurrentRot

if (myRotateFlag == false){return;}

sliderValue3 = jsonFloat_rotationOffset.val;
currentRot = sliderValue3;
var deltaRot= currentRot-keepCurrentRot;

myCameraRigTransform.RotateAround(keepWorld_posi, keepMyFoward, deltaRot);


keepCurrent();
myRotateFlag = true;

}
        
        
//KEEP current OVERLOAD///////////////////////////////
    public void keepCurrent()
    {

        myTransform = sc.MonitorCenterCamera.transform;
        currentFOV = sc.monitorCameraFOVSlider.value;
        currentPOI = sc.focusDistance;
        
    }
        
//////////////////////////////////////////////////////////////////////////////        
//KEEP current state for revert rotate cam///////////////////////////////
    public void keepCurrent(Vector3 myFoward,float currentRot,Vector3 world_posi)
    {

        //saveCam
        
        //myKeepRigTransform = myCameraRigTransform;
        //myKeepCameraTransform = myCameraTransform;

        keepMyFoward = myFoward;
        keepCurrentRot = currentRot;
        keepWorld_posi = world_posi;
        
        //SuperController.LogMessage("keepMyFoward = "+ keepMyFoward);
        //SuperController.LogMessage("keepCurrentRot = "+ keepCurrentRot);
        //SuperController.LogMessage("keepWorld_posi = "+ keepWorld_posi);
        
        myTransform = sc.MonitorCenterCamera.transform;
        currentFOV = sc.monitorCameraFOVSlider.value;
        currentPOI = sc.focusDistance;
        
    }
        
//////////////////////////////////////////////////////////////////////////////
//Reset BUTTON1
    public void buttonClickA()//RESET NORMAL
    {
        EnableTumble();//////////RightClick LOCK to free
       
       
       if (myRotateFlag == false){
	       autoRotateFlag = false;
       myImage[26].color = new Color(1f, 1f, 1f);
       myImage[27].color = new Color(1f, 1f, 1f);
	
	return;}
       
       
       if (currentCameraNo != 0){
          
          var i = currentCameraNo;

          revertCamera(i);/////////////////////////////////////TEMP0
          currentFOV = keepCamFOVs[i];
          currentPOI = keepCamPOIs[i];
          
          myImage[i+10].color = new Color(1f, 1f, 1f);
          
          currentCameraNo=0;

        }   else {

          revertCamera(0);/////////////////////////////////////TEMP0
          currentRot =0.0f;
          myRotateFlag = false;
          
          myImage[31].color = new Color(1f, 1f, 1f);
          myImage[30].color = new Color(1f, 1f, 1f);


          return;
         }
        

//----------------------------------------------------------


myCameraRigTransform.RotateAround(keepWorld_posi,keepMyFoward, -1*myCameraRigTransform.eulerAngles.z);
jsonFloat_rotationOffset.val = 90f;

//----------------------------------------------------------


      jsonFloat_FOV.val = currentFOV;
      sc.focusDistance = currentPOI;

      currentRot =0.0f;
      myRotateFlag = false;
        
      myImage[31].color = new Color(1f, 1f, 1f);
      myImage[30].color = new Color(1f, 1f, 1f);


       autoRotateFlag = false;
       myImage[26].color = new Color(1f, 1f, 1f);
       myImage[27].color = new Color(1f, 1f, 1f);



}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//OVERLOAD RESET Camera No Saving
  public void buttonClickA(int i)//RESET OVERLOAD
    {

       //SuperController.LogMessage("OVERLOAD buttonClickA");

        Vector3 localAngle = myTransform.localEulerAngles;
        localAngle.z = currentRot;
        myTransform.localEulerAngles = localAngle;

        }

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
    //BUTTON2
        public void buttonClickB()//L90 TURN
        {
               
        if (myRotateFlag == true){return;}
        
        keepCurrent();

        Transform myTransform = sc.MonitorCenterCamera.transform;
        Vector3 localAngle = myTransform.localEulerAngles;

        localAngle.z = -90.0f;
        currentRot =-90f;
        myTransform.localEulerAngles = localAngle;

        myRotateFlag = true;

        }

//////////////////////////////////////////////////////////////////////////////
    //BUTTON3
        public void buttonClickC()//R90 TURN
        {

        if (myRotateFlag == true){return;}

        Transform myTransform = sc.MonitorCenterCamera.transform;
        localAngle = myTransform.localEulerAngles;
        localAngle.z = sliderValue3;
        currentRot = sliderValue3;
        myTransform.localEulerAngles = localAngle;

        myRotateFlag = true;
        
        }
        
//////////////////////////////////////////////////////////////////////////////
    //BUTTON4 Fov FIT R90
        public void buttonClickD()//R90 fit
        {


        if (myRotateFlag == true)
        {
                 buttonClickA();

                 
                 return;
        }




        sliderValue3 = jsonFloat_rotationOffset.val;
        //currentRot = sliderValue3;
        currentRot = 90f;

        if (myScreenCenterEmpty != null){
        //SuperController.LogMessage(" myScreenCenterEmpty already EXISTS");
        //Destroy(myScreenCenterEmpty);
        }else{
             //sphere spawn by script
        myScreenCenterEmpty = new GameObject("EMPTY");
        }
        
        myScreenCenterEmpty.SetActive(true);

        Vector3 myAreaCenter = new Vector3(Screen.width/2 , Screen.height/2 , sc.focusDistance);
        Vector3 world_posi = Camera.main.ScreenToWorldPoint(myAreaCenter);

        myScreenCenterEmpty.transform.position = world_posi;
        
        Vector3 myFoward = sc.MonitorCenterCamera.transform.forward;





//--------------------------------------------------------
PointerClick_saveIcon(0);
//SuperController.LogMessage("R90fit PointerClick_saveIcon(0)");
//--------------------------------------------------------



        /////////////////////////////////////////////////////////////////////////////////////////////
        myCameraRigTransform.RotateAround(myScreenCenterEmpty.transform.position,myFoward, currentRot);
        /////////////////////////////////////////////////////////////////////////////////////////////

keepCurrent(myFoward,currentRot,world_posi);
//Destroy(myScreenCenterEmpty);

        float aspect = (float)myMonitorWidth / (float)myMonitorHeight;
        float targetFov = (float)jsonFloat_FOV.val / (float)aspect ;
        
            if (targetFov <= 20f)
            {
                float deltaFov = 20 - targetFov;
                 targetFov = 20f;
            }
        
        jsonFloat_FOV.val = targetFov;
        
        myRotateFlag = true;
        
        currentCameraNo = 0;
        //ResetCameraIcon();
        
        
        if  ((autoRotateFlag == true)&&(jsonFloat_orbitSpeed.val >0))
                  {
                   myImage[26].color = new Color(1f, 0.2f, 0.5f);
                   myImage[27].color = new Color(1f, 1f, 1f);
                  } else if ((autoRotateFlag == true)&&(jsonFloat_orbitSpeed.val <0)){
                   myImage[26].color = new Color(1f, 1f, 1f);
                   myImage[27].color = new Color(1f, 0.2f, 0.5f);
                  }

         //SuperController.LogMessage("ctrl+R");

                  myImage[30].color = new Color(1f, 0.2f, 0.5f);
                  myImage[31].color = new Color(1f, 1f, 1f);
                  
  
                  
        
}

//////////////////////////////////////////////////////////////////////////////
        //BUTTON7
        public void buttonClickG()//L90 fit
        {

        if (myRotateFlag == true)
        {
                 buttonClickA();
                 return;
        }


        sliderValue3 = jsonFloat_rotationOffset.val;
        //currentRot = sliderValue3;
        currentRot = -90f;

        if (myScreenCenterEmpty != null){
        //SuperController.LogMessage(" myScreenCenterEmpty already EXISTS");
        //return;
        }else{

        //sphere spawn by script
        myScreenCenterEmpty = new GameObject("EMPTY");
        }
        
        myScreenCenterEmpty.SetActive(true);

        Vector3 myAreaCenter = new Vector3(Screen.width/2 , Screen.height/2 , sc.focusDistance);
        Vector3 world_posi = Camera.main.ScreenToWorldPoint(myAreaCenter);

        myScreenCenterEmpty.transform.position = world_posi;

        Vector3 myFoward = sc.MonitorCenterCamera.transform.forward;


//--------------------------------------------------------
PointerClick_saveIcon(0);
//SuperController.LogMessage("PointerClick_saveIcon(0)");
//--------------------------------------------------------
        
        
        /////////////////////////////////////////////////////////////////////////////////////////////
        myCameraRigTransform.RotateAround(myScreenCenterEmpty.transform.position,myFoward, currentRot);
        /////////////////////////////////////////////////////////////////////////////////////////////

        keepCurrent(myFoward,currentRot,world_posi);
        //Destroy(myScreenCenterEmpty);

        float aspect = (float)myMonitorWidth / (float)myMonitorHeight;
        float targetFov = (float)jsonFloat_FOV.val / (float)aspect ;
        
            if (targetFov <= 20f)
            {
                float deltaFov = 20 - targetFov;
                 targetFov = 20f;
            }
        
        jsonFloat_FOV.val = targetFov;
        
        myRotateFlag = true;
        
        currentCameraNo = 0;
        ResetCameraIcon();
        
        
        if  ((autoRotateFlag == true)&&(jsonFloat_orbitSpeed.val >0))
                  {
                   myImage[26].color = new Color(1f, 0.2f, 0.5f);
                   myImage[27].color = new Color(1f, 1f, 1f);
                  } else if ((autoRotateFlag == true)&&(jsonFloat_orbitSpeed.val <0)){
                   myImage[26].color = new Color(1f, 1f, 1f);
                   myImage[27].color = new Color(1f, 0.2f, 0.5f);
                  }

         //SuperController.LogMessage("ctrl+L");

                  myImage[30].color = new Color(1f, 1f, 1f,1f);
                  myImage[31].color = new Color(1f, 0.2f, 0.5f);


        }
//////////////////////////////////////////////////////////////////////////////////////        
////////////////////////////////////////////////////////////////////////////////////// 
        
        //BUTTON_RefleshAtomList
        public void RefleshAtomList()//follow target list
        {
        
            //RemovePopup(atomJSON);
            //RemovePopup(receiverJSON);
            //RemoveTextField(helpText4);

            //followList PULLDOWN///////////////////////////////////
            
            List<string> targetChoices = new List<string>();
            //targetChoices.Add("None");//dammyData
            var atoms = SuperController.singleton.GetAtoms();
            foreach(var atom in atoms)
            {
                 //SuperController.LogMessage("atom =" + atom.name);
                 if((atom.type == "Person")||(atom.type == "Empty"))
                 {
                    //targetChoices.Add(atom.type);
                    targetChoices.Add(atom.name);
                 }
            }
            
            atomJSON.choices = targetChoices;
            SyncAtom(atomJSON.val);

        }
        
          

     protected void SyncControl(string ControlUID)
        {

            if (ControlUID != null)
            {
                
                //SuperController.LogMessage("ControlUID = "+ ControlUID);
                
                
            followAtom = SuperController.singleton.GetAtomByUid(atomJSON.val);
            target = GetTransform(followAtom, receiverJSON.val);
            //followSensitive =3.0f;
       
   
                offsetTarget = myCameraRig.position - target.position;
                
                

             }
        }
        //////////////////////////////////
        
              
        
        //BUTTON10/////////////////////////////////
        public void RefleshInfo()//test
        {
        
        Rescan();
        ResetUI();
        

        }


        //////////////////////////////////////////////////////////////////////////////
        //BUTTON5
        public void buttonClickE()//FULLSCREEN
        {
        Screen.SetResolution(myMonitorWidth, myMonitorHeight, true);	

        myAreaWidth = myMonitorWidth;
        myAreaHeight = myMonitorHeight;
        ResetUI();
        }
        //////////////////////////////////////////////////////////////////////////////
        //BUTTON6
        public void buttonClickF()//FULLSCREEN-80
        {

        Screen.SetResolution(myMonitorWidth, myMonitorHeight -80, true);
        myAreaWidth = myMonitorWidth;
        myAreaHeight = myMonitorHeight -80;
        ResetUI();
        //Screen.SetResolution(Screen.currentResolution.width, Screen.currentResolution.height, true);

        }
        //////////////////////////////////////////////////////////////////////////////
        //BUTTON8
        public void buttonClickH()//Windowed-70
        {

        myWorkWindowSize = (int)(myMonitorWidth * sliderValue2 /100f);
        
        //Screen.SetResolution(myMonitorWidth, myMonitorHeight -70, false);
        Screen.SetResolution(myWorkWindowSize, myMonitorHeight -70, false);
        
        //myAreaWidth = myMonitorWidth;
        myAreaWidth = myWorkWindowSize;
        myAreaHeight = myMonitorHeight -70;
        
        Invoke("Rescan", 0.1f);
        Invoke("ResetUI", 0.2f);
        
        }
        ////////////////////////////////////////////////////

        //////////////////////////////////////////////////////////////////////////////
        //SCREEN TOGGLE CHANGE
        public void ScreenToggleChange()
        {
            if (Screen.fullScreen == true){

                buttonClickH();//Windowed-70

            }else{

                buttonClickE();//FULLSCREEN

            }
        }

////////////////////////////////////////////////////
        // Runs once when plugin loads - after Init()
        protected void Start()
        {

        // show a message
        //SuperController.LogMessage(pluginLabelJSON.val + " Loaded");







         Invoke("CreateCameraChangerUI", 0f);
         

         if (myCameraChangerUI == false) {
                Invoke("DisableCameraChangerUI", 0f);
                //DisableCameraChangerUI();

         }else{
                Invoke("EnableCameraChangerUI", 0f);
                //EnableCameraChangerUI();
        
         }
         


         
        
        }

////////////////////////////////////////////////////
        // A Unity thing - runs every physics cycle
        public void FixedUpdate()
        {
            // put code here
            


        }
////////////////////////////////////////////////////

        //EnableCameraChangerUICallback///////////////////////
        private void CameraChangerUICallback(bool visibility) {

                if (myCameraChangerUI == false) {
 
                Invoke("EnableCameraChangerUI", 0f);
                myCameraChangerUI = true;

                } else {

                Invoke("DisableCameraChangerUI", 0f);
                myCameraChangerUI = false;		
                }
                  
        }

        //resetbyKey ON/OFF Callback//////////////////////////
        private void ResetByEscCallback(bool visibility) {

                if (myResetByEsc == false) {
                myResetByEsc = true;

                }else{
                myResetByEsc = false;		
                }
        }



       //AcceleMoveFlag ON/OFF Callback//////////////////////////
        private void AcceleMoveFlagCallback(bool visibility) {

                if (myAcceleMoveFlag == false) {
                myAcceleMoveFlag = true;
            
                }else{
                myAcceleMoveFlag = false;
                }
        }
        

       //FollowCamFlag ON/OFF Callback//////////////////////////
        private void FollowCamFlagCallback(bool CHK) {

                if (autoRotateFlag == true){
                    FollowCamFlag.val = false;
                    myImage[32].color = new Color(0.3f, 0.3f, 0.3f);
                    return;
                }
                

                if (CHK == true) {

                myFollowCamFlag = true;
                myImage[32].color = new Color(1f, 0.3f, 0.6f);
            //SuperController.LogMessage("atomJSON.val = "+ atomJSON.val); 
            //SuperController.LogMessage("receiverJSON.val = "+ receiverJSON.val); 
       
       
       if ((atomJSON.val != "None")&&(receiverJSON.val != "None"))
       {

            followAtom = SuperController.singleton.GetAtomByUid(atomJSON.val);
            target = GetTransform(followAtom, receiverJSON.val);
            followSensitive = jsonFloat_followSmooth.val;
       
            offsetTarget = myCameraRig.position - target.position;
       }   
                
                //SuperController.LogMessage("FollowCamFlag TRUE!");
                
            
                }else if (CHK == false){

                myFollowCamFlag = false;
                myImage[32].color = new Color(0.3f, 0.3f, 0.3f);
                //SuperController.LogMessage("FollowCamFlag false!!!!!!!!");
                }
                
 
                
        }
        
        
        

        //resetbyKey ON/OFF Callback//////////////////////////
        private void ResetByShiftCallback(bool visibility) {

                if (myResetByShift == false) {
                myResetByShift = true;
            
                }else{
                myResetByShift = false;
                }
        }
        
        
        //NumKeyCamChange ON/OFF Callback//////////////////////////
        private void NumKeyCamChangeCallback(bool visibility) {

                if (myNumKeyCamChange == false) {
                myNumKeyCamChange = true;
            
                }else{
                myNumKeyCamChange = false;
                }
        }
        
        
        //ArrowKeyCamChange ON/OFF Callback//////////////////////////
        private void ArrowKeyCamChangeCallback(bool visibility) {

                if (myArrowKeyCamChange == false) {
                myArrowKeyCamChange = true;
            
                }else{
                myArrowKeyCamChange = false;
                }
        }
        
        
        //R90rotate ON/OFF Callback//////////////////////////
        private void R90rotateCallback(bool visibility) {

                if (myR90rotate == false) {
                myR90rotate = true;
            
                }else{
                myR90rotate = false;		
                }
        }
        
        //L90rotate ON/OFF Callback//////////////////////////
        private void L90rotateCallback(bool visibility) {

                if (myL90rotate == false) {
                myL90rotate = true;
            
                }else{
                myL90rotate = false;		
                }
        }
        //ScreenToggle ON/OFF Callback//////////////////////////
        private void ScreenToggleCallback(bool visibility) {

                if (myScreenToggle == false) {
                myScreenToggle = true;
            
                }else{
                myScreenToggle = false;		
                }
        }
///////////////////////////////////////////////////////////////////////////// 

////////////////////////////////////////////////////////////////////////////////////
     private void CreateUI(){

        if (myCanvas == null){
                return;
        }
        
        if (cameraUIgo != null){
                Destroy(cameraUIgo);
        }
        
        if (UIgo != null){
                Destroy(UIgo);
        }

        
        UIgo = new GameObject();
        UIgo.transform.SetParent(myCanvas.transform, false);
        
        cameraUIgo = new GameObject();
        cameraUIgo.transform.SetParent(myCanvas.transform, false);

        Create_pullIcon();
        
        Create_saveIcon(1);
        Create_saveIcon(2);
        Create_saveIcon(3);
        Create_saveIcon(4);
        Create_saveIcon(5);
        Create_saveIcon(6);
        Create_saveIcon(7);
        Create_saveIcon(8);
        Create_saveIcon(9);
        Create_saveIcon(10);
        
        Create_cameraIcon(1);
        Create_cameraIcon(2);
        Create_cameraIcon(3);
        Create_cameraIcon(4);
        Create_cameraIcon(5);
        Create_cameraIcon(6);
        Create_cameraIcon(7);
        Create_cameraIcon(8);
        Create_cameraIcon(9);
        Create_cameraIcon(10);
        
        Create_backIcon();
        Create_nextIcon();
        
        Create_resetIcon();
        
        Create_orbitRIcon();
        Create_orbitLIcon();
        
        Create_R90fitIcon();
        Create_L90fitIcon();
        
        Create_followCamIcon();

        UIflag = true;
        oldHeight = Screen.height;
        
       ResetCameraIcon();

}

///////////////////////////////////////////////////////
        public void OnDisable()
         {

SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;
SuperController.singleton.onBeforeSceneSaveHandlers -= OnBeforeSceneSave;
     
buttonClickA();//if saved scene with 90rotated, fatal problem when opened it again

        clear_canvas();	
        Destroy(myCanvas);
        myCanvas.enabled = false;
        
        UITextString.val = "";
        
        //RESET Rotate
        Vector3 localAngle = myTransform.localEulerAngles;
        currentRot =0.0f;
        localAngle.z = 0.0f;
        myTransform.localEulerAngles = localAngle;
        
        }

////////////////////////////////////////////////////////
        private void clear_canvas()
        {
	    myImage = null;
		
            if (myCanvas == null)
                return;

            if (SuperController.singleton != null)
                SuperController.singleton.RemoveCanvas(myCanvas);

            myCanvas.transform.SetParent(null, false);

            if (myCanvas.gameObject != null)
                GameObject.Destroy(myCanvas.gameObject);
   
        }
////////////////////////////////////////////////////////







////////////////////////////////////////////////////////

 private void Create_pullIcon()
        {

        var filepath= Utils.GetPluginPath(this) + "/img/hide.png";

        byte[] tmppng = MVR.FileManagementSecure.FileManagerSecure.ReadAllBytes(filepath);
        Texture2D tex2d = new Texture2D(1, 1, TextureFormat.RGBA32, false);
        tex2d.LoadImage(tmppng);

        //SuperController.LogMessage("filepath = " +filepath );

        offsetV = 30;
        offsetH = -370;
        imageH = 140;
        imageV = 65;

        var myGo = new GameObject();
        
        myGo.transform.SetParent(UIgo.transform, false);
        
        RectTransform myRectTransform = myGo.AddComponent<RectTransform>();
        
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, imageH);
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, imageV);
        
        myGo.AddComponent<SpriteRenderer>();
        myGo.AddComponent<EventTrigger>();
        myGo.AddComponent<GraphicRaycaster>();
        
        myImage[25] = myGo.AddComponent<Image>();
        
        //Texture2D tex2d = TextureLoader.LoadTexture(filepath);
        

        
        myImage[25].sprite = Sprite.Create(tex2d, new Rect(0,0,tex2d.width,tex2d.height), Vector2.zero);
        
        myAreaHeight = Screen.height;


        myRectTransform.anchoredPosition = new Vector2(offsetH+50,(myAreaHeight/2)-offsetV);

        var clickListener = myGo.AddComponent<ClickListener>();
        
        myImage[25].color = new Color(0.8f, 0.8f, 0.8f);

        clickListener.onPointerDown.AddListener(() => {
             myImage[25].color = new Color(1f, 0.2f, 0.5f);
                
        });
        clickListener.onPointerEnter.AddListener(() => {
	     myImage[25].color = new Color(1f, 1f, 1f);

	     //cameraUIgo.SetActive (true);

        });
        clickListener.onPointerExit.AddListener(() => {
		
		
		
	if (cameraUIgo.activeSelf == false){
                myImage[25].color = new Color(0.8f, 0.8f,0.8f,0f);
        } else {
	        myImage[25].color = new Color(0.8f, 0.8f, 0.8f,1f);
	        
	}

	
        });
        clickListener.onPointerClick.AddListener(() => {
            //myImage[25].color = new Color(1f, 1f, 1f,0f);
            if (cameraUIgo.activeSelf){
		myImage[25].color = new Color(1f, 1f, 1f);
                cameraUIgo.SetActive (false);
        } else {
	        cameraUIgo.SetActive (true);
	        myImage[25].color = new Color(1f, 1f, 1f);
	        UIgo.SetActive (true);	
	}
		
        });
        
        }
////////////////////////////////////////////////////////

        private void Create_nextIcon()
        {

        var filepath= Utils.GetPluginPath(this) + "/img/next.png";

        byte[] tmppng = MVR.FileManagementSecure.FileManagerSecure.ReadAllBytes(filepath);
        Texture2D tex2d = new Texture2D(1, 1, TextureFormat.RGBA32, false);
        tex2d.LoadImage(tmppng);
        
        offsetV = 43;
        offsetH = 260;
        imageH = 30;
        imageV = 30;

        var myGo = new GameObject();
        myGo.transform.SetParent(cameraUIgo.transform, false);
        RectTransform myRectTransform = myGo.AddComponent<RectTransform>();
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, imageH);
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, imageV);
        myGo.AddComponent<SpriteRenderer>();
        myGo.AddComponent<EventTrigger>();
        myGo.AddComponent<GraphicRaycaster>();
        myImage[24] = myGo.AddComponent<Image>();
        //Texture2D tex2d = TextureLoader.LoadTexture(filepath);
        myImage[24].sprite = Sprite.Create(tex2d, new Rect(0,0,tex2d.width,tex2d.height), Vector2.zero);
        myAreaHeight = Screen.height;
        myRectTransform.anchoredPosition = new Vector2(offsetH+50,(myAreaHeight/2)-offsetV);

        var clickListener = myGo.AddComponent<ClickListener>();
             myImage[24].color = new Color(0.8f, 0.8f, 0.8f);
        
        clickListener.onPointerDown.AddListener(() => {
             myImage[24].color = new Color(1f, 0.2f, 0.5f);
                
        });
        clickListener.onPointerEnter.AddListener(() => {
	     myImage[24].color = new Color(1f, 1f, 1f);


        });
        clickListener.onPointerExit.AddListener(() => {

                myImage[24].color = new Color(0.8f, 0.8f,0.8f,1f);
        
        });
        
        clickListener.onPointerClick.AddListener(() => {
            myImage[24].color = new Color(1f, 1f, 1f,1f);
            
            /////////////////NEXT CAMERA////////////////
            
            NextCamera();

            /////////////////NEXT CAMERA////////////////

        });
        
  }
////////////////////////////////////////////////////////
 private void Create_resetIcon()
        {

        var filepath= Utils.GetPluginPath(this) + "/img/viewReset.png";

        byte[] tmppng = MVR.FileManagementSecure.FileManagerSecure.ReadAllBytes(filepath);
        Texture2D tex2d = new Texture2D(1, 1, TextureFormat.RGBA32, false);
        tex2d.LoadImage(tmppng);
        
        offsetV = 10;
        offsetH = 243;
        imageH = 70;
        imageV = 15;

        var myGo = new GameObject();
        
        myGo.transform.SetParent(cameraUIgo.transform, false);
        
        RectTransform myRectTransform = myGo.AddComponent<RectTransform>();
        
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, imageH);
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, imageV);
        
        myGo.AddComponent<SpriteRenderer>();
        myGo.AddComponent<EventTrigger>();
        myGo.AddComponent<GraphicRaycaster>();
        
        myImage[22] = myGo.AddComponent<Image>();
        
        //Texture2D tex2d = TextureLoader.LoadTexture(filepath);

        myImage[22].sprite = Sprite.Create(tex2d, new Rect(0,0,tex2d.width,tex2d.height), Vector2.zero);
        
        myAreaHeight = Screen.height;

        myRectTransform.anchoredPosition = new Vector2(offsetH+50,(myAreaHeight/2)-offsetV);

        var clickListener = myGo.AddComponent<ClickListener>();
        
        myImage[22].color = new Color(0.8f, 0.8f, 0.8f);

        clickListener.onPointerDown.AddListener(() => {
             myImage[22].color = new Color(1f, 0.2f, 0.5f);
                
        });
        clickListener.onPointerEnter.AddListener(() => {
	     myImage[22].color = new Color(1f, 1f, 1f);


        });
        clickListener.onPointerExit.AddListener(() => {

                myImage[22].color = new Color(0.8f, 0.8f,0.8f,1f);
        
        });
        
        clickListener.onPointerClick.AddListener(() => {
            myImage[22].color = new Color(1f, 1f, 1f,1f);
            
            
        ////////////////SOS BUTTON////////////////
        
        buttonClickA();
        SuperController.singleton.MoveToSceneLoadPosition();

        myCamera = SuperController.singleton.MonitorCenterCamera.transform;

        myCamera.localRotation = Quaternion.Euler(0f,0f, 0f);//temporary OK

                    FollowCamFlag.val = false;
                    myFollowCamFlag = false;
                    myImage[32].color = new Color(0.3f, 0.3f, 0.3f);
        /////////////////SOS BUTTON////////////////
            
        });
        
  }
////////////////////////////////////////////////////////

       private void Create_orbitRIcon()
        {

        var filepath= Utils.GetPluginPath(this) + "/img/orbitR.png";

        byte[] tmppng = MVR.FileManagementSecure.FileManagerSecure.ReadAllBytes(filepath);
        Texture2D tex2d = new Texture2D(1, 1, TextureFormat.RGBA32, false);
        tex2d.LoadImage(tmppng);
        
        offsetV = 46;
        offsetH = 310;
        imageH = 40;
        imageV = 25;

        var myGo = new GameObject();
        
        myGo.transform.SetParent(cameraUIgo.transform, false);
        
        RectTransform myRectTransform = myGo.AddComponent<RectTransform>();
        
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, imageH);
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, imageV);
        
        myGo.AddComponent<SpriteRenderer>();
        myGo.AddComponent<EventTrigger>();
        myGo.AddComponent<GraphicRaycaster>();
        
        myImage[26] = myGo.AddComponent<Image>();
        
        //Texture2D tex2d = TextureLoader.LoadTexture(filepath);

        myImage[26].sprite = Sprite.Create(tex2d, new Rect(0,0,tex2d.width,tex2d.height), Vector2.zero);
        
        myAreaHeight = Screen.height;

        myRectTransform.anchoredPosition = new Vector2(offsetH+50,(myAreaHeight/2)-offsetV);

        var clickListener = myGo.AddComponent<ClickListener>();
        
        myImage[26].color = new Color(1f, 1f, 1f);

        clickListener.onPointerDown.AddListener(() => {

                
        });
        clickListener.onPointerEnter.AddListener(() => {
	    
               
        });
        clickListener.onPointerExit.AddListener(() => {

               
        });
        
        clickListener.onPointerClick.AddListener(() => {



        ////////////////orbitR BUTTON////////////////
        if ((jsonFloat_orbitSpeed.val <0) &&(autoRotateFlag == false))
        {
        jsonFloat_orbitSpeed.val = -1*(jsonFloat_orbitSpeed.val);
        buttonClickI();
        } else if ((jsonFloat_orbitSpeed.val >0)&&(autoRotateFlag == true)) {
        autoRotateFlag = false;
        myImage[26].color = new Color(1f, 1f, 1f);
        myImage[27].color = new Color(1f, 1f, 1f);
        }else if ((jsonFloat_orbitSpeed.val >0)&&(autoRotateFlag == false)) {
        buttonClickI();
        } else if ((jsonFloat_orbitSpeed.val< 0)&&(autoRotateFlag == true)) {
        jsonFloat_orbitSpeed.val = -1*(jsonFloat_orbitSpeed.val);
        //buttonClickI();
        myImage[26].color = new Color(1f, 0.2f, 0.5f);
        myImage[27].color = new Color(1f, 1f, 1f);
        }
        
        
   
        /////////////////orbitR BUTTON////////////////
            
        });
        
  }

///////////////////////////////////////////////////////////////

        private void Create_orbitLIcon()
        {

        var filepath= Utils.GetPluginPath(this) + "/img/orbitL.png";

        byte[] tmppng = MVR.FileManagementSecure.FileManagerSecure.ReadAllBytes(filepath);
        Texture2D tex2d = new Texture2D(1, 1, TextureFormat.RGBA32, false);
        tex2d.LoadImage(tmppng);
        
        offsetV = 18;
        offsetH = 310;
        imageH = 40;
        imageV = 25;

        var myGo = new GameObject();
        
        myGo.transform.SetParent(cameraUIgo.transform, false);
        
        RectTransform myRectTransform = myGo.AddComponent<RectTransform>();
        
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, imageH);
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, imageV);
        
        myGo.AddComponent<SpriteRenderer>();
        myGo.AddComponent<EventTrigger>();
        myGo.AddComponent<GraphicRaycaster>();
        
        myImage[27] = myGo.AddComponent<Image>();
        
        //Texture2D tex2d = TextureLoader.LoadTexture(filepath);

        myImage[27].sprite = Sprite.Create(tex2d, new Rect(0,0,tex2d.width,tex2d.height), Vector2.zero);
        myAreaHeight = Screen.height;
        myRectTransform.anchoredPosition = new Vector2(offsetH+50,(myAreaHeight/2)-offsetV);
        var clickListener = myGo.AddComponent<ClickListener>();
        myImage[27].color = new Color(1f, 1f, 1f);
        clickListener.onPointerDown.AddListener(() => {

                
        });
        clickListener.onPointerEnter.AddListener(() => {
 

        });
        clickListener.onPointerExit.AddListener(() => {


        });
        
        clickListener.onPointerClick.AddListener(() => {

    
   
        ////////////////orbitL BUTTON////////////////


        
        
        if ((jsonFloat_orbitSpeed.val >0) &&(autoRotateFlag == false))
        {
        jsonFloat_orbitSpeed.val = -1*(jsonFloat_orbitSpeed.val);
        buttonClickI();
        } else if ((jsonFloat_orbitSpeed.val <0)&&(autoRotateFlag == true)) {
        autoRotateFlag = false;
        myImage[26].color = new Color(1f, 1f, 1f);
        myImage[27].color = new Color(1f, 1f, 1f);
        }else if ((jsonFloat_orbitSpeed.val <0)&&(autoRotateFlag == false)) {
        buttonClickI();
        } else if ((jsonFloat_orbitSpeed.val> 0)&&(autoRotateFlag == true)) {
        jsonFloat_orbitSpeed.val = -1*(jsonFloat_orbitSpeed.val);
        //buttonClickI();
        myImage[26].color = new Color(1f, 1f, 1f);
        myImage[27].color = new Color(1f, 0.2f, 0.5f);
        }
        
        
        
        
        
     
        /////////////////orbitL BUTTON////////////////
            
        });
        
  }


///////////////////////////////////////////////////////

        private void Create_backIcon()
        {

        var filepath= Utils.GetPluginPath(this) + "/img/back.png";

        byte[] tmppng = MVR.FileManagementSecure.FileManagerSecure.ReadAllBytes(filepath);
        Texture2D tex2d = new Texture2D(1, 1, TextureFormat.RGBA32, false);
        tex2d.LoadImage(tmppng);
        
        offsetV = 43;
        offsetH = 225;
        imageH = 30;
        imageV = 30;

        var myGo = new GameObject();
        
        myGo.transform.SetParent(cameraUIgo.transform, false);
        
        RectTransform myRectTransform = myGo.AddComponent<RectTransform>();
        
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, imageH);
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, imageV);
        
        myGo.AddComponent<SpriteRenderer>();
        myGo.AddComponent<EventTrigger>();
        myGo.AddComponent<GraphicRaycaster>();
        
        myImage[23] = myGo.AddComponent<Image>();
        
        //Texture2D tex2d = TextureLoader.LoadTexture(filepath);

        myImage[23].sprite = Sprite.Create(tex2d, new Rect(0,0,tex2d.width,tex2d.height), Vector2.zero);
        
        myAreaHeight = Screen.height;

        myRectTransform.anchoredPosition = new Vector2(offsetH+50,(myAreaHeight/2)-offsetV);

        var clickListener = myGo.AddComponent<ClickListener>();
        
        myImage[23].color = new Color(0.8f, 0.8f, 0.8f);

        clickListener.onPointerDown.AddListener(() => {
             myImage[23].color = new Color(1f, 0.2f, 0.5f);
                
        });
        clickListener.onPointerEnter.AddListener(() => {
	     myImage[23].color = new Color(1f, 1f, 1f);


        });
        clickListener.onPointerExit.AddListener(() => {

                myImage[23].color = new Color(0.8f, 0.8f,0.8f,1f);
        
        });
        
        clickListener.onPointerClick.AddListener(() => {
            myImage[23].color = new Color(1f, 1f, 1f,1f);
            
            
        /////////////////Before CAMERA////////////////
            
        BeforeCamera();
     
        /////////////////Before CAMERA////////////////
            
        });
        
  }
  
  
////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////// 

       private void Create_R90fitIcon()
        {

        var filepath= Utils.GetPluginPath(this) + "/img/R90.png";

        byte[] tmppng = MVR.FileManagementSecure.FileManagerSecure.ReadAllBytes(filepath);
        Texture2D tex2d = new Texture2D(1, 1, TextureFormat.RGBA32, false);
        tex2d.LoadImage(tmppng);
        

        
        offsetV = 32;
        offsetH = 355;
        imageH = 30;
        imageV = 53;

        var myGo = new GameObject();
        
        myGo.transform.SetParent(cameraUIgo.transform, false);
        
        RectTransform myRectTransform = myGo.AddComponent<RectTransform>();
        
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, imageH);
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, imageV);
        
        myGo.AddComponent<SpriteRenderer>();
        myGo.AddComponent<EventTrigger>();
        myGo.AddComponent<GraphicRaycaster>();
        
        myImage[30] = myGo.AddComponent<Image>();
        
        //Texture2D tex2d = TextureLoader.LoadTexture(filepath);

        myImage[30].sprite = Sprite.Create(tex2d, new Rect(0,0,tex2d.width,tex2d.height), Vector2.zero);
        
        myAreaHeight = Screen.height;

        myRectTransform.anchoredPosition = new Vector2(offsetH+50,(myAreaHeight/2)-offsetV);

        var clickListener = myGo.AddComponent<ClickListener>();
        
        myImage[30].color = new Color(1f, 1f, 1f);

        clickListener.onPointerDown.AddListener(() => {

                
        });
        clickListener.onPointerEnter.AddListener(() => {

               
        });
        clickListener.onPointerExit.AddListener(() => {
            
               
        });
        
        clickListener.onPointerClick.AddListener(() => {



        ////////////////R90fit BUTTON////////////////
        
                //SuperController.LogMessage("ctrl+R");
                if (myRotateFlag == true){
                       //autoRotateFlag = false;
                       
                       
                //myFollowCamFlag = false;
                //myImage[32].color = new Color(0.3f, 0.3f, 0.3f);       
                       
                       
                       buttonClickA();//Reset rotate
                       
                if (FollowCamFlag.val == true){
		offsetTarget = myCameraRig.position - target.position;   
                myFollowCamFlag = true;
                myImage[32].color = new Color(1f, 0.3f, 0.6f);
                }  
                       
                }else{
                       //autoRotateFlag = false;
                       
                       
                //myFollowCamFlag = false;
                //myImage[32].color = new Color(0.3f, 0.3f, 0.3f);
                       
                       buttonClickD();//Rotate
                       
                if (FollowCamFlag.val == true){
		offsetTarget = myCameraRig.position - target.position;   
                myFollowCamFlag = true;
                myImage[32].color = new Color(1f, 0.3f, 0.6f);
                }  
                 }
        
        /////////////////R90fit BUTTON////////////////
            
        });
        
  }  
////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////  
  
       private void Create_L90fitIcon()
        {

        var filepath= Utils.GetPluginPath(this) + "/img/L90.png";

        byte[] tmppng = MVR.FileManagementSecure.FileManagerSecure.ReadAllBytes(filepath);
        Texture2D tex2d = new Texture2D(1, 1, TextureFormat.RGBA32, false);
        tex2d.LoadImage(tmppng);
        
        offsetV = 32;
        offsetH = 390;
        imageH = 30;
        imageV = 53;

        var myGo = new GameObject();
        
        myGo.transform.SetParent(cameraUIgo.transform, false);
        
        RectTransform myRectTransform = myGo.AddComponent<RectTransform>();
        
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, imageH);
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, imageV);
        
        myGo.AddComponent<SpriteRenderer>();
        myGo.AddComponent<EventTrigger>();
        myGo.AddComponent<GraphicRaycaster>();
        
        myImage[31] = myGo.AddComponent<Image>();
        
        //Texture2D tex2d = TextureLoader.LoadTexture(filepath);

        myImage[31].sprite = Sprite.Create(tex2d, new Rect(0,0,tex2d.width,tex2d.height), Vector2.zero);
        
        myAreaHeight = Screen.height;

        myRectTransform.anchoredPosition = new Vector2(offsetH+50,(myAreaHeight/2)-offsetV);

        var clickListener = myGo.AddComponent<ClickListener>();
        
        myImage[31].color = new Color(1f, 1f, 1f);

        clickListener.onPointerDown.AddListener(() => {

                
        });
        clickListener.onPointerEnter.AddListener(() => {
	    
               
        });
        clickListener.onPointerExit.AddListener(() => {

               
        });
        
        clickListener.onPointerClick.AddListener(() => {



        ////////////////L90fit BUTTON////////////////
        
        
                //SuperController.LogMessage("ctrl+L");
                if (myRotateFlag == true){
                       //autoRotateFlag = false;
                       
                       
                //myFollowCamFlag = false;
                //myImage[32].color = new Color(0.3f, 0.3f, 0.3f);       
                       
                       buttonClickA();
                       
                if (FollowCamFlag.val == true){
		offsetTarget = myCameraRig.position - target.position;   
                myFollowCamFlag = true;
                myImage[32].color = new Color(1f, 0.3f, 0.6f);
                }  
                       
                 }else{
                       //autoRotateFlag = false;
                       
                //myFollowCamFlag = false;
                //myImage[32].color = new Color(0.3f, 0.3f, 0.3f);      
                       
                       
                       buttonClickG();
                       
                if (FollowCamFlag.val == true){
		offsetTarget = myCameraRig.position - target.position;   
                myFollowCamFlag = true;
                myImage[32].color = new Color(1f, 0.3f, 0.6f);
                }  
                

                 }
        
        
   
        /////////////////L90fit BUTTON////////////////
            
        });
        
  }  
  
  
////////////////////////////////////////////////////////  
////////////////////////////////////////////////////////  
////////////////////////////////////////////////////////
  
       private void Create_followCamIcon()
        {

        var filepath= Utils.GetPluginPath(this) + "/img/followCam.png";

        byte[] tmppng = MVR.FileManagementSecure.FileManagerSecure.ReadAllBytes(filepath);
        Texture2D tex2d = new Texture2D(1, 1, TextureFormat.RGBA32, false);
        tex2d.LoadImage(tmppng);
        
        offsetV = 20;
        offsetH = 438;
        imageH = 49;
        imageV = 30;

        var myGo = new GameObject();
        
        myGo.transform.SetParent(cameraUIgo.transform, false);
        
        RectTransform myRectTransform = myGo.AddComponent<RectTransform>();
        
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, imageH);
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, imageV);
        
        myGo.AddComponent<SpriteRenderer>();
        myGo.AddComponent<EventTrigger>();
        myGo.AddComponent<GraphicRaycaster>();
        
        myImage[32] = myGo.AddComponent<Image>();
        
        //Texture2D tex2d = TextureLoader.LoadTexture(filepath);

        myImage[32].sprite = Sprite.Create(tex2d, new Rect(0,0,tex2d.width,tex2d.height), Vector2.zero);
        
        myAreaHeight = Screen.height;

        myRectTransform.anchoredPosition = new Vector2(offsetH+50,(myAreaHeight/2)-offsetV);

        var clickListener = myGo.AddComponent<ClickListener>();
        
        myImage[32].color = new Color(1f, 1f, 1f);

        clickListener.onPointerDown.AddListener(() => {

                
        });
        clickListener.onPointerEnter.AddListener(() => {
	    
               
        });
        clickListener.onPointerExit.AddListener(() => {

               
        });
        
        clickListener.onPointerClick.AddListener(() => {



        ////////////////followCam Button Action////////////////
        
                //SuperController.LogMessage("followCam Button");

                if (autoRotateFlag == true){
                    FollowCamFlag.val = false;
                    myImage[32].color = new Color(0.3f, 0.3f, 0.3f);
                    return;
                }
                

                if (myFollowCamFlag == false) {

                myFollowCamFlag = true;
                FollowCamFlag.val = true;
                myImage[32].color = new Color(1f, 0.3f, 0.6f);
            //SuperController.LogMessage("atomJSON.val = "+ atomJSON.val); 
            //SuperController.LogMessage("receiverJSON.val = "+ receiverJSON.val); 
       
       
              if ((atomJSON.val != "None")&&(receiverJSON.val != "None"))
              {

            followAtom = SuperController.singleton.GetAtomByUid(atomJSON.val);
            target = GetTransform(followAtom, receiverJSON.val);
            followSensitive = jsonFloat_followSmooth.val;
       
            offsetTarget = myCameraRig.position - target.position;
             }   
                

                
            
                }else if (myFollowCamFlag == true){

                myFollowCamFlag = false;
                FollowCamFlag.val = false;
                myImage[32].color = new Color(0.3f, 0.3f, 0.3f);
                //SuperController.LogMessage("FollowCamFlag false!!!!!!!!");
                }

          
   
        /////////////////followCam Button////////////////
            
        });
        
  }  
  
  
  
  
  
  
  
  
////////////////////////////////////////////////////////  
////////////////////////////////////////////////////////  
////////////////////////////////////////////////////////
       private void NextCamera(){

     //when all flag is vacant,must skip loop
     
     bool camExist = false;
     
     for(int j = 1; j < 11; j++)
     {

        if (saveFlag[j] == true)
        {
          camExist = true;
          break;
        }
     }

     if(camExist == false){return;}


     ////////////////////////////////////////////////////       

      if( currentCameraNo != 0)
      { 
      myImage[currentCameraNo+10].color = new Color(1f, 1f, 1f);
      }

if( currentCameraNo < 1){ currentCameraNo = 10;}
if( currentCameraNo > 10){ currentCameraNo = 1;}

          int i = currentCameraNo;
 
           while (i < 11)
           {
                if (i==10){i=0;}
                
                ++i;
 
                if (saveFlag[i] == true)
                {

                      if(activeCoroutine != null) StopCoroutine(activeCoroutine);
                      activeCoroutine = null;
                      activeCoroutine = RestoreCameraSlerp(i);
                      StartCoroutine(activeCoroutine);

                //StartCoroutine(RestoreCameraSlerp(i));
                 myImage[i+10].color = new Color(1f, 0f, 0f);
                 break;
                 }

           }

       }
////////////////////////////////////////////////////////
       private void BeforeCamera()
       {

     //when all flag is vacant,must skip loop
     
     bool camExist = false;
     
     for(int j = 1; j < 11; j++)
     {

        if (saveFlag[j] == true)
        {
          camExist = true;
          break;
        }
     }

     if(camExist == false){return;}

     ////////////////////////////////////////////////////   


     if( currentCameraNo != 0)
     { 
         myImage[currentCameraNo+10].color = new Color(1f, 1f, 1f);
     }
         
           if( currentCameraNo < 1){ currentCameraNo = 10;}
           if( currentCameraNo > 10){ currentCameraNo = 1;}
 
           int i = currentCameraNo;
          while (i > 0)
          { 
              if (i==1){ i=11;}
                --i;
              if (saveFlag[i] == true)
             {
                      if(activeCoroutine != null) StopCoroutine(activeCoroutine);
                      activeCoroutine = null;
                      activeCoroutine = RestoreCameraSlerp(i);
                      StartCoroutine(activeCoroutine);
               //StartCoroutine(RestoreCameraSlerp(i));
               myImage[i+10].color = new Color(1f, 0f, 0f);
               break;
             }

          }

       }
////////////////////////////////////////////////////////
        private void Create_cameraIcon(int i)
        {

        var filepath= Utils.GetPluginPath(this) + "/img/cam"+(i)+".png";

        byte[] tmppng = MVR.FileManagementSecure.FileManagerSecure.ReadAllBytes(filepath);
        Texture2D tex2d = new Texture2D(1, 1, TextureFormat.RGBA32, false);
        tex2d.LoadImage(tmppng);
        
        offsetV = 43;
        offsetH = -275;
        imageH = 40;
        imageV = 40;

        var myGo = new GameObject();
        
        myGo.transform.SetParent(cameraUIgo.transform, false);
        
        RectTransform myRectTransform = myGo.AddComponent<RectTransform>();
        
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, imageH);
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, imageV);
        
        myGo.AddComponent<SpriteRenderer>();
        myGo.AddComponent<EventTrigger>();
        myGo.AddComponent<GraphicRaycaster>();
        
        myImage[i+10] = myGo.AddComponent<Image>();
        
        //Texture2D tex2d = TextureLoader.LoadTexture(filepath);
        
        myImage[i+10].sprite = Sprite.Create(tex2d, new Rect(0,0,tex2d.width,tex2d.height), Vector2.zero);
        
        myAreaHeight = Screen.height;


        myRectTransform.anchoredPosition = new Vector2(offsetH+50*i,(myAreaHeight/2)-offsetV);

        var clickListener = myGo.AddComponent<ClickListener>();
        
        myImage[i+10].color = new Color(0.3f, 0.3f, 0.3f);

        clickListener.onPointerDown.AddListener(() => {
                PointerDown_cameraIcon(i);
                
        });
        clickListener.onPointerEnter.AddListener(() => {
		PointerEnter_cameraIcon(i);

        });
        clickListener.onPointerExit.AddListener(() => {
		PointerExit_cameraIcon(i);
		
        });
        clickListener.onPointerClick.AddListener(() => {
		PointerClick_cameraIcon(i);
		
        });
        
        }
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
        private void Create_saveIcon(int i)
        {

        
        offsetV = 10;
        offsetH = -275;
        imageH = 40;
        imageV = 15;

        var myGo = new GameObject();
        myGo.transform.SetParent(cameraUIgo.transform, false);
        
        RectTransform myRectTransform = myGo.AddComponent<RectTransform>();
        
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, imageH);
        myRectTransform.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, imageV);
        
        myGo.AddComponent<SpriteRenderer>();
        myGo.AddComponent<EventTrigger>();
        myGo.AddComponent<GraphicRaycaster>();
        
        myImage[i] = myGo.AddComponent<Image>();
        
        //tex2d = TextureLoader.LoadTexture(filepath);
        //tex2dSave = TextureLoader.LoadTexture(filepath2);

        var filepath= Utils.GetPluginPath(this) + "/img/saveButton.png";

        byte[] tmppng = MVR.FileManagementSecure.FileManagerSecure.ReadAllBytes(filepath);
        Texture2D tex2dSave = new Texture2D(1, 1, TextureFormat.RGBA32, false);
        tex2dSave.LoadImage(tmppng);
     
        
        
        myImage[i].sprite = Sprite.Create(tex2dSave, new Rect(0,0,40,15), Vector2.zero);
        myAreaHeight = Screen.height;
        myRectTransform.anchoredPosition = new Vector2(offsetH+50*i,(myAreaHeight/2)-offsetV);

        var clickListener = myGo.AddComponent<ClickListener>();
        
        myImage[i].color = new Color(1.0f, 1.0f, 1.0f);

        clickListener.onPointerDown.AddListener(() => {
             PointerDown_saveIcon(i);
             
        });
        
        clickListener.onPointerRightDown.AddListener(() => {
             PointerRightDown_saveIcon(i);
             
        });
        
        
        clickListener.onPointerEnter.AddListener(() => {
             PointerEnter_saveIcon(i);
        });
        clickListener.onPointerExit.AddListener(() => {
             PointerExit_saveIcon(i);
        });
        clickListener.onPointerClick.AddListener(() => {
             PointerClick_saveIcon(i);

        });
         clickListener.onPointerRightClick.AddListener(() => {
             PointerRightClick_saveIcon(i);

        });
        
        
        }

///////////////////////////////////////////////////////
        private void PointerDown_saveIcon(int i)
        {

           myImage[i].color = new Color(1f, 0.5f, 0.8f);	
 
        }
/////////////////////////////////////////////////////////
                private void PointerRightDown_saveIcon(int i)
        {


                if (saveFlag[i] == false) {
                   myImage[i].color = new Color(1f, 0.5f, 0.8f);

                } else {
                   
                   var filepath2= Utils.GetPluginPath(this) + "/img/delButton.png";
        
                   byte[] tmppng2 = MVR.FileManagementSecure.FileManagerSecure.ReadAllBytes(filepath2);
                   Texture2D tex2dDel = new Texture2D(1, 1, TextureFormat.RGBA32, false);
                   tex2dDel.LoadImage(tmppng2);
                   
                   
                   myImage[i].sprite = Sprite.Create(tex2dDel, new Rect(0,0,40,15), Vector2.zero);
                   myImage[i].color = new Color(1f, 1f, 1f);
                }
 
        }
///////////////////////////////////////////////////////////////
        private void PointerEnter_saveIcon(int i)
        {

           myImage[i].color = new Color(0.5f, 0.5f, 0.5f);	

        }
/////////////////////////////////////////////////////////////////        
        private void PointerExit_saveIcon(int i)
        {
    
        var filepath= Utils.GetPluginPath(this) + "/img/saveButton.png";

        byte[] tmppng = MVR.FileManagementSecure.FileManagerSecure.ReadAllBytes(filepath);
        Texture2D tex2dSave = new Texture2D(1, 1, TextureFormat.RGBA32, false);
        tex2dSave.LoadImage(tmppng);

        myImage[i].sprite = Sprite.Create(tex2dSave, new Rect(0,0,40,15), Vector2.zero);
        myImage[i].color = new Color(1f, 1f, 1f);	
 
        }
////////////////////////////////////////////////////////////////////////                
        private void PointerClick_saveIcon(int i)
        {




               saveFlag[i] = true;
               currentCameraNo = i;
               
               ResetCameraIcon();
                              
               if (i == 0){}else{
                   myImage[i+10].color = new Color(1f, 0.0f, 0.0f);
               }

               saveCamera(i);

        }
////////////////////////////////////////////////////////////////////////  
        private void PointerRightClick_saveIcon(int i)   /////////DELETE CAMERA//////////
        {
                saveFlag[i] = false;
                currentCameraNo = i;

                myImage[i+10].color = new Color(0.1f, 0.1f, 0.1f);
                
                ResetCameraIcon();
                //myImage[ (currentCameraNo+10) ].color = new Color(1f, 0f, 0f);
                saveCamera(i);
                currentCameraNo = 0;

        }

///////////////////////////////////////////////////////
        private void PointerDown_cameraIcon(int i)
        {
                if (saveFlag[i] == false) {

                } else {
                   myImage[i+10].color = new Color(1f, 0.5f, 0.8f);
                }

        }
        
        private void PointerEnter_cameraIcon(int i)
        {

                if (saveFlag[i] == false) {
                
                } else if (currentCameraNo == i){
                      myImage[i+10].color = new Color(1f, 0f, 0f);
                } else if (currentCameraNo != i){
                      myImage[i+10].color = new Color(0.7f, 0.7f, 0.7f);	
                }
        }
        
        private void PointerExit_cameraIcon(int i)
        {
                if (saveFlag[i] == false) {

                } else if (currentCameraNo == i){
                      myImage[i+10].color = new Color(1f, 0f, 0f);
                } else if (currentCameraNo != i){
                      myImage[i+10].color = new Color(1f, 1f, 1f);	
                }
        }
                
        private void PointerClick_cameraIcon(int i)
        {

                if (saveFlag[i] == false) {

                } else {
                      currentCameraNo = i;
                      
                      ResetCameraIcon();
                      myImage[i+10].color = new Color(1f, 0f, 0f);
                      //restoreCamera(i);
                      
                      if(activeCoroutine != null) StopCoroutine(activeCoroutine);
                      activeCoroutine = null;
                      activeCoroutine = RestoreCameraSlerp(i);
                      StartCoroutine(activeCoroutine);

                }
                
        }
///////////////////////////////////////////////////////
        private void ResetCameraIcon()
        {

             for(int i = 1; i < 11; i++)
             {
                  if (saveFlag[i] == false) {
                  myImage[i+10].color = new Color(0.3f, 0.3f, 0.3f);
                  } else {
                          
                      myImage[i+10].color = new Color(1f, 1f, 1f);
                  }
             }
        }
///////////////////////////////////////////////////////  

    public static IEnumerator CreateAtomCo(string type, string basename, Action<Atom> onAtomCreated)
    {
    string uid = NewUID(basename);
    yield return SuperController.singleton.AddAtomByType(type, uid, false);
    var atom = SuperController.singleton.GetAtomByUid(uid);
    
    
    
        if(atom == null)
        {
        throw new NullReferenceException("atom was not created");
        }
    
    onAtomCreated(atom);

    }


   //adapted from Acidbubbles on Discord 27/02/2021
   public static string NewUID(string basename)
   {
    var uids = new HashSet<string>(SuperController.singleton.GetAtomUIDs());
    if(!uids.Contains(basename))
    {
        return basename;
    }

    for(int i = 2; i < 1000; i++)
    {
        string uid = $"{basename}#{i}";
        if(!uids.Contains(uid))
        {
            return uid;
        }
    }

    // you don't really want to be here 
    return basename + Guid.NewGuid();
    }

/////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////
    public static Vector3 StringToVector3(string input)
    {
        var elements = input.Trim('(', ')').Split(',');
        var result = Vector3.zero;
        var elementCount = Mathf.Min(elements.Length, 3);
        for (var i = 0; i < elementCount; i++)
        {
            float value;
            float.TryParse(elements[i], out value);
            result[i] = value;
        }
        return result;
    }

/////////////////////////////////////////////////////////////////////////////

        public void saveCamera(int i)
        {

        //SuperController.LogMessage("START saveCamera");

        currentCameraNo = i;

            myCamera = SuperController.singleton.MonitorCenterCamera.transform;
            myCameraRig = myCamera.parent.parent;
            
            
            //when rotate, keepCurrentParamater

            if (currentCameraNo == 0){
                 keepCamRotates[0] = myTransform.eulerAngles;
                 keepCamRigPosis[0] = myCameraRig.position;
                 keepCamRigRotates[0] = myCameraRig.eulerAngles;
            } else {

                 keepCamRotates[i] = keepCamRotates[0];
                 keepCamRigPosis[i] = keepCamRigPosis[0];
                 keepCamRigRotates[i] = keepCamRigRotates[0];
            
            }
            
            
            keepCamFOVs[i] = currentFOV;
            keepCamPOIs[i] = currentPOI;

            camRotates[i] = myCamera.eulerAngles;             
            camRigPosis[i] = myCameraRig.position;            
            camRigRotates[i] = myCameraRig.eulerAngles;
            
            camHeights[i] = sc.playerHeightAdjust;
            camFOVs[i] = sc.monitorCameraFOVSlider.value;
            camPOIs[i] = sc.focusDistance;
            currentRots[i] = currentRot;

            leapDurations[i] = jsonFloat_leapDuration.val;
            
            
            /////////////////////////////////////
            if (myScreenCenterEmpty != null){
            
            
            orbitCenterPosis[i] = myScreenCenterEmpty.transform.position;
            
               if (autoRotateFlag == true){
               orbitSpeeds[i] = jsonFloat_orbitSpeed.val;
               } else {
               orbitSpeeds[i] = 0f;
               }
            }

            /////////////////////////////////////
            
            ///////////AcceleMove/////////////////
            if (myAcceleMoveFlag == true){
               AcceleMoveFlags[i] = true;
            } else {
               AcceleMoveFlags[i] = false;
            }
            ///////////AcceleMove/////////////////
            
            ///////////FollowCamFlags/////////////////

            FollowCamFlags[i] = myFollowCamFlag;

            FollowTargetAtoms[i] = atomJSON.val;
            FollowTargetControls[i] = receiverJSON.val;

            FollowSensitives[i] = jsonFloat_followSmooth.val;
            


///////////////////////////////////////

        if (currentCameraNo == 0){
                saveFlag[0] = true;
        } else {
               saveFlag[0] = false;
        }      

////////////////////////////////////////          



            ArrayDataToUIText();
            
            //SuperController.LogMessage("END saveCamera");
 }

/////////////////////////////////////////////////////////////////////////////   
     private void ArrayDataToUIText()
     {

         for(int i = 0; i < 11; i++){

          var currentdata = i+"!"+camRotates[i]+"!"+ camRigPosis[i] +"!"+ camRigRotates[i] +"!"+ camHeights[i] +"!"+ camFOVs[i] +"!"+ camPOIs[i] +"!"+currentRots[i]+"!"+ keepCamFOVs[i] +"!"+ keepCamPOIs[i] +"!"+saveFlag[i]+"!"+orbitSpeeds[i]+"!"+orbitCenterPosis[i]+"!"+keepCamRotates[i]+"!"+keepCamRigPosis[i]+"!"+keepCamRigRotates[i]+"!"+leapDurations[i]+"!"+AcceleMoveFlags[i]+"!"+FollowCamFlags[i]+"!"+FollowTargetAtoms[i]+"!"+FollowTargetControls[i]+"!"+FollowSensitives[i]+"!0!0!0!0";


                    if (saveFlag[i] == false){
                      saveDatas[i] = i+"!(0,0,0)!(0,0,0)!(0,0,0)!0!40!0!0!0!0!False!0!(0,0,0)!(0,0,0)!(0,0,0)!(0,0,0)!0!False!False!None!None!0!0!0!0!0";
                    }else{
                      saveDatas[i] = currentdata;
                    }

           }
            string saveDataString = string.Join ("\n", saveDatas);
            string str0 = saveDataString.Replace(" ", "");
            
            UITextString.val = str0;

     }
////////////////////////////////////////////////////////////////////////////////////////////////////////
        private Transform GetTransform(Atom atom, string controlID){
            return atom?.GetStorableByID(controlID)?.transform;
        }
////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////
      private IEnumerator RestoreCameraSlerp(int i)
        {
FollowCamFlag.val = false;

        currentCameraNo = i;

        Transform myTransform = sc.MonitorCenterCamera.transform;
        localAngle = myTransform.localEulerAngles;
        
  /////////////////////////////
  if (currentCameraNo == 0){

        currentRot = localAngle.z;
  }else{
        currentRot = currentRots[i];
        jsonFloat_rotationOffset.val = currentRot;
  }
  /////////////////////////////
  

            if (currentRot != 0f){
                  myRotateFlag = true;
             
                  if (currentRot > 0f){
                       myImage[31].color = new Color(1f, 1f, 1f);
                       myImage[30].color = new Color(1f, 0.2f, 0.5f);
                  }else{
                       myImage[30].color = new Color(1f, 1f, 1f);
                       myImage[31].color = new Color(1f, 0.2f, 0.5f);	
                   }

             } else {
                   myRotateFlag = false;
           
                       myImage[30].color = new Color(1f, 1f, 1f);
                       myImage[31].color = new Color(1f, 1f, 1f);

                       jsonFloat_rotationOffset.val = 90f;          
           
                       EnableTumble();//////////RightClick LOCK to free
             }

        ////////////////////////////
        ////////////////////////////

        if (orbitSpeeds[i] != 0)
        {
		if (myScreenCenterEmpty == null){
                  //EMPTY spawn by script
                  myScreenCenterEmpty = new GameObject("EMPTY");
                }
                
                myScreenCenterEmpty.transform.position = orbitCenterPosis[i];

                jsonFloat_orbitSpeed.val = orbitSpeeds[i];

                autoRotateFlag = true;

                if  (jsonFloat_orbitSpeed.val >0)
                  {
                   myImage[26].color = new Color(1f, 0.2f, 0.5f);
                   myImage[27].color = new Color(1f, 1f, 1f);
                  } else {
                   myImage[26].color = new Color(1f, 1f, 1f);
                   myImage[27].color = new Color(1f, 0.2f, 0.5f);
                  }

          }else{

                   autoRotateFlag = false;
                   myImage[26].color = new Color(1f, 1f, 1f);
                   myImage[27].color = new Color(1f, 1f, 1f);
          }

          /////////////////////////////////////

            Vector3 rigPosOld = myCameraRig.position;
            
            float rigRotXOld = myCameraRig.eulerAngles.x;
            float rigRotYOld = myCameraRig.eulerAngles.y;
            float rigRotZOld = myCameraRig.eulerAngles.z;
            
            float camRotXOld = myCamera.eulerAngles.x;

            Vector3 rigPosNew = camRigPosis[i];
            
            float rigRotXNew = camRigRotates[i].x;
            float rigRotYNew = camRigRotates[i].y;
            float rigRotZNew = camRigRotates[i].z;
            
            float camRotXNew = camRotates[i].x;
              
            var rigRotOldQ = Quaternion.Euler(rigRotXOld, rigRotYOld, rigRotZOld);
            var rigRotNewQ = Quaternion.Euler(rigRotXNew, rigRotYNew, rigRotZNew);
              
            var camRotOldQ = Quaternion.Euler(camRotXOld, 0f, 0f);
            var camRotNewQ = Quaternion.Euler(camRotXNew, 0f, 0f);

            float heightOld = sc.playerHeightAdjust;
            float focusOld = sc.focusDistance;
            
            float heightNew = camHeights[i];
            float focusNew = camPOIs[i];

            float fovOld = sc.monitorCameraFOVSlider.value;
            float fovNew = camFOVs[i];
            

            
            float leapDuration = leapDurations[i];//how long (s) arrives Goal

            //jsonFloat_leapDuration.val = leapDuration;
            
            //var leapSpeed = 2/(3*leapDuration);//Speed
            //var leapSpeedHigh = 10/(2*leapDuration);//HighSpeed
            
            var leapSpeed = 1/leapDuration;//Speed
            var leapSpeedLow = 3/(8*leapDuration);//LowSpeed
            var leapSpeedHigh = 6/(leapDuration);//HighSpeed
            
            float leapt;



//////////////////////////

           myFollowCamFlagTemp2 = true;

//////////////////////////            
            

            float t = 0f;//start

            while (t < 1f)
            {

                if ((Input.GetMouseButtonDown(0))||(Input.GetMouseButtonDown(1))||(Input.GetMouseButtonDown(2))||(Input.GetAxis("Mouse ScrollWheel") != 0.0f)){t = 1f;}
                
                
                t = t + leapSpeed * Time.deltaTime;
                
                if (t > 1f){t = 1f;}
                
                
                ////////AcceleMove//////////////////////////////////////
                if (AcceleMoveFlags[i] == true)
                {

                  leapSpeed = leapSpeedLow;

/*
                //pattern1
                if ((t > 0f)&&(t < 0.3f)){t = 0.3f;}//pat1
                if ((t > 0.50f)&&(t < 0.70f)){t = 0.70f;}//pat1
                
                //pattern2
                if ((t > 0.20f)&&(t < 0.4f)){t = 0.4f;}//pat1
                if ((t > 0.6f)&&(t < 0.9f)){t = 0.9f;}//pat1
                

               //pattern3
                if ((t > 0.20f)&&(t < 0.5f)){t = 0.5f;}//pat1
                if ((t > 0.7f)&&(t <1f)){t = 1f;}//pat1

                leapt = t;//Not Ease Linear
                
                } else {

                leapt = (t * t) * (3f - (2f * t));//EaseIN EaseOut
                }



               //pattern4
                if (t > 0.3f){
                  leapSpeed = leapSpeedHigh;

                }

                leapt = t;//Not Ease Linear
                
                } else {

                leapt = (t * t) * (3f - (2f * t));//EaseIN EaseOut
                }
*/


  
                
               //pattern5
                if (t > 0.3f){
                  leapSpeed = leapSpeedHigh;

                }

                leapt = t;//Not Ease Linear
                
                } else {

                leapt = (t * t) * (3f - (2f * t));//EaseIN EaseOut
                }


                ////////AcceleMove//////////////////////////////////////

                //float leapt = t;//Linear

                //Slerp-A///////////////////////////////////////////
                myCameraRig.position = Vector3.Lerp(rigPosOld, rigPosNew, leapt);
                myCameraRig.rotation = Quaternion.Lerp(rigRotOldQ, rigRotNewQ, leapt);
                myCamera.localRotation = Quaternion.Lerp(camRotOldQ, camRotNewQ, leapt);
                sc.playerHeightAdjust = Mathf.Lerp(heightOld, heightNew, leapt);
                sc.focusDistance = Mathf.Lerp(focusOld, focusNew, leapt);
                sc.monitorCameraFOVSlider.value = Mathf.Lerp(fovOld, fovNew, leapt);
                //////////////////////////////////////////////////


/*
                //Slerp-B///////////////////////////////////////////
                myCameraRig.position = Vector3.Lerp(rigPosOld, rigPosNew, leapt);
                myCameraRig.rotation = Quaternion.Slerp(rigRotOldQ, rigRotNewQ, leapt);
                myCamera.localRotation = Quaternion.Slerp(camRotOldQ, camRotNewQ, leapt);
                sc.playerHeightAdjust = Mathf.Lerp(heightOld, heightNew, leapt);
                sc.focusDistance = Mathf.Lerp(focusOld, focusNew, leapt);
                sc.monitorCameraFOVSlider.value = Mathf.Lerp(fovOld, fovNew, leapt);
                //////////////////////////////////////////////////
                 

                //Slerp-C///////////////////////////////////////////
                myCameraRig.position = Vector3.Slerp(rigPosOld, rigPosNew, leapt);
                myCameraRig.rotation = Quaternion.Slerp(rigRotOldQ, rigRotNewQ, leapt);
                myCamera.localRotation = Quaternion.Slerp(camRotOldQ, camRotNewQ, leapt);
                sc.playerHeightAdjust = Mathf.Lerp(heightOld, heightNew, leapt);
                sc.focusDistance = Mathf.Lerp(focusOld, focusNew, leapt);
                sc.monitorCameraFOVSlider.value = Mathf.Lerp(fovOld, fovNew, leapt);
                //////////////////////////////////////////////////
*/               

                yield return new WaitForFixedUpdate();
            }

             

             
////////////////////////////////////
             myFollowCamFlagTemp2 = false;

    ////////followCam////
          atomJSON.val = FollowTargetAtoms[i];
          receiverJSON.val = FollowTargetControls[i];
          jsonFloat_followSmooth.val = FollowSensitives[i];
          FollowCamFlag.val = FollowCamFlags[i];
////////////////////////////////////
             
            //SuperController.LogMessage("End Lerp");
            

  }

////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////
 
    public void restoreCamera(int i)
        {
        currentCameraNo = i;

        Transform myTransform = sc.MonitorCenterCamera.transform;
        localAngle = myTransform.localEulerAngles;

  if (currentCameraNo == 0){

        currentRot = localAngle.z;

  }else{
        currentRot = currentRots[i];
        jsonFloat_rotationOffset.val = currentRot;
  }

            float rigPosX = camRigPosis[i].x;
            float rigPosY = camRigPosis[i].y;
            float rigPosZ = camRigPosis[i].z;
            
            float rigRotX = camRigRotates[i].x;
            float rigRotY = camRigRotates[i].y;
            float rigRotZ = camRigRotates[i].z;
            
            float camRotX = camRotates[i].x;

    Vector3 pos = myCameraRig.position;
       pos.x = rigPosX;
       pos.y = rigPosY;  
       pos.z = rigPosZ; 
    myCameraRig.position = pos; 
            
    sc.playerHeightAdjust = camHeights[i];  
            
    myCameraRig.rotation = Quaternion.Euler(rigRotX, rigRotY, rigRotZ);  //OK

    myCamera.localRotation = Quaternion.Euler(camRotX, 0f, 0f);  //OK

            sc.monitorCameraFOVSlider.value = camFOVs[i];
            sc.focusDistance = camPOIs[i];
            
        ////////////////////////////////////

        if (orbitSpeeds[i] != 0)
        {
		if (myScreenCenterEmpty == null){
                  //EMPTY spawn by script
                  myScreenCenterEmpty = new GameObject("EMPTY");
                }
                
                myScreenCenterEmpty.transform.position = orbitCenterPosis[i];
                jsonFloat_orbitSpeed.val = orbitSpeeds[i];

                autoRotateFlag = true;

                if  (jsonFloat_orbitSpeed.val >0)
                  {
                   myImage[26].color = new Color(1f, 0.2f, 0.5f);
                   myImage[27].color = new Color(1f, 1f, 1f);
                  } else {
                   myImage[26].color = new Color(1f, 1f, 1f);
                   myImage[27].color = new Color(1f, 0.2f, 0.5f);
                  }

        }else{
                autoRotateFlag = false;
                myImage[26].color = new Color(1f, 1f, 1f);
                myImage[27].color = new Color(1f, 1f, 1f);
                }

            /////////////////////////////////////
            
                if (currentRot != 0f){
                  myRotateFlag = true;
             
                  if (currentRot > 0f){
                       myImage[31].color = new Color(1f, 1f, 1f);
                       myImage[30].color = new Color(1f, 0.2f, 0.5f);
                }else{
                       myImage[30].color = new Color(1f, 1f, 1f);
                       myImage[31].color = new Color(1f, 0.2f, 0.5f);	
                }

       } else {
           myRotateFlag = false;
           
                       myImage[30].color = new Color(1f, 1f, 1f);
                       myImage[31].color = new Color(1f, 1f, 1f);

           jsonFloat_rotationOffset.val = 90f;          
           
           EnableTumble();//////////RightClick LOCK to free
           }

        }
        
        
///////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////
   public void revertCamera(int i)
        {
        currentCameraNo = i;

        Transform myTransform = sc.MonitorCenterCamera.transform;
        localAngle = myTransform.localEulerAngles;

            float rigPosX;
            float rigPosY;
            float rigPosZ;
            
            float rigRotX;
            float rigRotY;
            float rigRotZ;
            
            float camRotX;
            
            

  if (currentCameraNo == 0){


        currentRot = localAngle.z;

            rigPosX = keepCamRigPosis[0].x;
            rigPosY = keepCamRigPosis[0].y;
            rigPosZ = keepCamRigPosis[0].z;
            
            rigRotX = keepCamRigRotates[0].x;
            rigRotY = keepCamRigRotates[0].y;
            rigRotZ = keepCamRigRotates[0].z;
            
            camRotX = keepCamRotates[0].x;

  }else{


        currentRot = currentRots[i];
        jsonFloat_rotationOffset.val = currentRot; 
        
        
            rigPosX = keepCamRigPosis[i].x;
            rigPosY = keepCamRigPosis[i].y;
            rigPosZ = keepCamRigPosis[i].z;
            
            rigRotX = keepCamRigRotates[i].x;
            rigRotY = keepCamRigRotates[i].y;
            rigRotZ = keepCamRigRotates[i].z;
            
            camRotX = keepCamRotates[i].x;
        
        
  }
  
  


    Vector3 pos = myCameraRig.position;
       pos.x = rigPosX;
       pos.y = rigPosY;  
       pos.z = rigPosZ; 
    myCameraRig.position = pos; 
            
    sc.playerHeightAdjust = camHeights[i];  //OK
    myCameraRig.rotation = Quaternion.Euler(rigRotX, rigRotY, rigRotZ);  //OK
    myCamera.localRotation = Quaternion.Euler(camRotX, 0f, 0f);  //OK
    sc.monitorCameraFOVSlider.value = camFOVs[i]; //OK
    sc.focusDistance = camPOIs[i]; //OK
            
            ////////////////////////////////////
            if (orbitSpeeds[i] != 0)
            {
		if (myScreenCenterEmpty == null){
                  //EMPTY spawn by script
                  myScreenCenterEmpty = new GameObject("EMPTY");
                }
		
		myScreenCenterEmpty.transform.position = orbitCenterPosis[i];
		jsonFloat_orbitSpeed.val = orbitSpeeds[i];

		autoRotateFlag = true;
		
		if  (jsonFloat_orbitSpeed.val >0)
                  {
                   myImage[26].color = new Color(1f, 0.2f, 0.5f);
                   myImage[27].color = new Color(1f, 1f, 1f);
                  } else {
		   myImage[26].color = new Color(1f, 1f, 1f);
                   myImage[27].color = new Color(1f, 0.2f, 0.5f);
                  }
	
	}else{
		autoRotateFlag = false;
		myImage[26].color = new Color(1f, 1f, 1f);
		myImage[27].color = new Color(1f, 1f, 1f);
		}
		
            /////////////////////////////////////
            
           if (currentRot != 0f){
             myRotateFlag = true;
             
                  if (currentRot > 0f){
                       myImage[31].color = new Color(1f, 1f, 1f);
                       myImage[30].color = new Color(1f, 0.2f, 0.5f);
             }else{
                       myImage[30].color = new Color(1f, 1f, 1f);
                       myImage[31].color = new Color(1f, 0.2f, 0.5f);	
             }
             
             
           } else {
           myRotateFlag = false;
           
                       myImage[30].color = new Color(1f, 1f, 1f);
                       myImage[31].color = new Color(1f, 1f, 1f);
           
           

           jsonFloat_rotationOffset.val = 90f;          
           
           EnableTumble();//////////RightClick LOCK to free
           }

        }
        
        
      
///////////////////////////////////////////////////////////////////



   public void DisableTumble(){
           GlobalSceneOptions.singleton.disableNavigation = true;
           SuperController.singleton.disableNavigation = true;
   }
   
   
   public void EnableTumble(){
           GlobalSceneOptions.singleton.disableNavigation = false;
           SuperController.singleton.disableNavigation = false;
   }
///////////////////////////////////////////////////////////////////////////////////////////////////////

        

//////////////////////////////////
        // receiver Atom
        protected void SyncAtom(string atomUID)
        {
            List<string> receiverChoices = new List<string>();
            if (atomUID != null)
            {

                //SuperController.LogMessage("atomUID = "+ atomUID);
                receivingAtom = SuperController.singleton.GetAtomByUid(atomUID);
                if (receivingAtom != null)
                {

                   if (receivingAtom.type == "Person")
                    {
                        
                        receiverChoices.Add("head");
                        receiverChoices.Add("headControl");
                        receiverChoices.Add("neck");
                        receiverChoices.Add("neckControl");
                        receiverChoices.Add("chest");
                        receiverChoices.Add("chestControl");
                        receiverChoices.Add("pelvis");
                        receiverChoices.Add("pelvisControl");
                        receiverChoices.Add("hip");
                        receiverChoices.Add("hipControl");
                        receiverChoices.Add("control");

                    }
                   if (receivingAtom.type == "Empty")
                    {
                        
                        receiverChoices.Add("control");

                    }
                    
                    receiverJSON.choices = receiverChoices;
                    

                    
               }
            }
            else
            {
                receivingAtom = null;
            }
            receiverJSON.choices = receiverChoices;
            //receiverJSON.val = "neck";
            
           //SuperController.LogMessage(atomJSON.val);
           //SuperController.LogMessage(receiverJSON.val);
           //SuperController.LogMessage("SyncAtom END");
            

            
        }
///////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////
    void LateUpdate()
    {
	
	
	
       if ((myFollowCamFlag == true)&&(myFollowCamFlagTemp == true)){

           myCameraRig.position = Vector3.Lerp(myCameraRig.position, target.position + offsetTarget, jsonFloat_followSmooth.val * Time.deltaTime);
       }
       
       
       
       
       if (FollowCamFlag.val == false){return;}

       if ((myFollowCamFlagTemp == true)&&(Input.GetMouseButton(1))||(Input.GetMouseButton(2))||(Input.GetAxis("Mouse ScrollWheel") != 0.0f))
       {
           myFollowCamFlagTemp = false;
           return;
       }


       if ((myFollowCamFlagTemp == false)&&((Input.GetMouseButtonUp(1))||(Input.GetMouseButtonUp(2))||(Input.GetAxis("Mouse ScrollWheel") == 0.0f))){

          myFollowCamFlagTemp = true;
          
          offsetTarget = myCameraRig.position - target.position; 
          
          //SuperController.LogMessage("MouseUp follow Enable");

       }


        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////////
// Unity thing - runs every rendered frame
       public void Update()
       {




             if (((oldHeight > (Screen.height)+15)||(oldHeight < (Screen.height)-15))&&(UIflag == true)) {
                //SuperController.LogMessage("Window Changed");
                UIflag = false;
                CreateUI();
             }
             

         /////NEW ORBIT ROTATE/////////////////////////////////


//SuperController.LogMessage("myFollowCamFlagTemp = " +myFollowCamFlagTemp);
//SuperController.LogMessage("autoRotateFlag = " +autoRotateFlag);
//SuperController.LogMessage("FollowCamFlag.val = " + FollowCamFlag.val);
//SuperController.LogMessage("myFollowCamFlag = " + myFollowCamFlag);



  if (FollowCamFlag.val == true) {
	
	
            if ((myFollowCamFlagTemp3 == false)&&((myFollowCamFlagTemp2 == true)||(autoRotateFlag == true))){

                  myFollowCamFlag = false;
                  FollowCamFlag.val = false;
                  myFollowCamFlagTemp3 = true;
                  return;
            }
 }else{           
            
            
            if ((myFollowCamFlagTemp3 == true)&&(myFollowCamFlagTemp2 == false)&&(autoRotateFlag == false)){

                  myFollowCamFlag = true;
                  FollowCamFlag.val = true;
                  myFollowCamFlagTemp3 = false;
                  return;
            }
            
            
  }   
  
       
            
 



        if (autoRotateFlag == true){

            
            ////////////////////////////////////////////////////////////////////////////////////////////////////
            myCameraRigTransform.RotateAround(myScreenCenterEmpty.transform.position,new Vector3(0,1,0), jsonFloat_orbitSpeed.val);
            ////////////////////////////////////////////////////////////////////////////////////////////////////
            

        }

  
        
        
/////NEW ORBIT ROTATE/////////////////////////////////


//Force Rotate Hack
      if (currentRot == 0f)
          {
            EnableTumble();
          }

   if((Input.GetMouseButton(1))&&(currentRot != 0f))
      {
      DisableTumble();
    }

       if (Input.GetMouseButton(2))
          { 
             EnableTumble();
          }

      if (Input.GetAxis("Mouse ScrollWheel") != 0.0f)
          {
          EnableTumble();
          }

            //SHORTCUT by key
            
            
      if (myArrowKeyCamChange == true) {      
            if (Input.GetKeyDown(KeyCode.RightArrow)) {
                 NextCamera();
            }
            
            if (Input.GetKeyDown(KeyCode.LeftArrow)) {
                 BeforeCamera();
            }
       }//myArrowKeyCamChange
            

      if (myNumKeyCamChange == true) {

            if ((Input.GetKeyDown(KeyCode.Alpha1))&&(saveFlag[1] != false)) {
                currentCameraNo = 1;
                
                ResetCameraIcon();
                myImage[1+10].color = new Color(1f, 0f, 0f);
                
                if(activeCoroutine != null) StopCoroutine(activeCoroutine);
                activeCoroutine = null;
                activeCoroutine = RestoreCameraSlerp(1);
                StartCoroutine(activeCoroutine);
                
            }
            if ((Input.GetKeyDown(KeyCode.Alpha2))&&(saveFlag[2] != false)) {
                currentCameraNo = 2;
                
                ResetCameraIcon();
                myImage[2+10].color = new Color(1f, 0f, 0f);
                
                if(activeCoroutine != null) StopCoroutine(activeCoroutine);
                activeCoroutine = null;
                activeCoroutine = RestoreCameraSlerp(2);
                StartCoroutine(activeCoroutine);
                
            }
            if ((Input.GetKeyDown(KeyCode.Alpha3))&&(saveFlag[3] != false)) {
                currentCameraNo = 3;
                
                ResetCameraIcon();
                myImage[3+10].color = new Color(1f, 0f, 0f);
                
                if(activeCoroutine != null) StopCoroutine(activeCoroutine);
                activeCoroutine = null;
                activeCoroutine = RestoreCameraSlerp(3);
                StartCoroutine(activeCoroutine);
            }
            if ((Input.GetKeyDown(KeyCode.Alpha4))&&(saveFlag[4] != false)) {
                currentCameraNo = 4;
                
                ResetCameraIcon();
                myImage[4+10].color = new Color(1f, 0f, 0f);
                
                if(activeCoroutine != null) StopCoroutine(activeCoroutine);
                activeCoroutine = null;
                activeCoroutine = RestoreCameraSlerp(4);
                StartCoroutine(activeCoroutine);
            }
            if ((Input.GetKeyDown(KeyCode.Alpha5))&&(saveFlag[5] != false)) {
                currentCameraNo = 5;
                
                ResetCameraIcon();
                myImage[5+10].color = new Color(1f, 0f, 0f);
                
                if(activeCoroutine != null) StopCoroutine(activeCoroutine);
                activeCoroutine = null;
                activeCoroutine = RestoreCameraSlerp(5);
                StartCoroutine(activeCoroutine);
            }
            if ((Input.GetKeyDown(KeyCode.Alpha6))&&(saveFlag[6] != false)) {
                currentCameraNo = 6;
                
                ResetCameraIcon();
                myImage[6+10].color = new Color(1f, 0f, 0f);
                
                if(activeCoroutine != null) StopCoroutine(activeCoroutine);
                activeCoroutine = null;
                activeCoroutine = RestoreCameraSlerp(6);
                StartCoroutine(activeCoroutine);
            }            
            if ((Input.GetKeyDown(KeyCode.Alpha7))&&(saveFlag[7] != false)) {
                currentCameraNo = 7;
                
                ResetCameraIcon();
                myImage[7+10].color = new Color(1f, 0f, 0f);
                
                if(activeCoroutine != null) StopCoroutine(activeCoroutine);
                activeCoroutine = null;
                activeCoroutine = RestoreCameraSlerp(7);
                StartCoroutine(activeCoroutine);
            }
            if ((Input.GetKeyDown(KeyCode.Alpha8))&&(saveFlag[8] != false)) {
                currentCameraNo = 8;
                
                ResetCameraIcon();
                myImage[8+10].color = new Color(1f, 0f, 0f);
                
                if(activeCoroutine != null) StopCoroutine(activeCoroutine);
                activeCoroutine = null;
                activeCoroutine = RestoreCameraSlerp(8);
                StartCoroutine(activeCoroutine);
            }
            if ((Input.GetKeyDown(KeyCode.Alpha9))&&(saveFlag[9] != false)) {
                currentCameraNo = 9;
                
                ResetCameraIcon();
                myImage[9+10].color = new Color(1f, 0f, 0f);
                
                if(activeCoroutine != null) StopCoroutine(activeCoroutine);
                activeCoroutine = null;
                activeCoroutine = RestoreCameraSlerp(9);
                StartCoroutine(activeCoroutine);
            }
            if ((Input.GetKeyDown(KeyCode.Alpha0))&&(saveFlag[10] != false)) {
                currentCameraNo = 10;
                
                ResetCameraIcon();
                myImage[10+10].color = new Color(1f, 0f, 0f);
                
                if(activeCoroutine != null) StopCoroutine(activeCoroutine);
                activeCoroutine = null;
                activeCoroutine = RestoreCameraSlerp(10);
                StartCoroutine(activeCoroutine);
            }  
            
      }//myNumKeyCamChange



            
            if ((Input.GetKeyDown(KeyCode.LeftShift))&&(myResetByShift == true)) {
                buttonClickA();
                
                if (FollowCamFlag.val == true){
		offsetTarget = myCameraRig.position - target.position;   
                myFollowCamFlag = true;
                myImage[32].color = new Color(1f, 0.3f, 0.6f);
                } 
                
            }
            
            
            
            if ((Input.GetKeyDown (KeyCode.Escape))&&(myResetByEsc == true)) {
                 buttonClickA();
                 
                if (FollowCamFlag.val == true){
		offsetTarget = myCameraRig.position - target.position;   
                myFollowCamFlag = true;
                myImage[32].color = new Color(1f, 0.3f, 0.6f);
                } 
                
                
            }
            
            if ((Input.GetKey(KeyCode.LeftControl))&&(Input.GetKeyDown(KeyCode.R))){
            
                //SuperController.LogMessage("ctrl+R");
                if (myRotateFlag == true){
                       buttonClickA();//Reset rotate
                       
                       
                if (FollowCamFlag.val == true){
		offsetTarget = myCameraRig.position - target.position;   
                myFollowCamFlag = true;
                myImage[32].color = new Color(1f, 0.3f, 0.6f);
                } 
                       
                       
                }else{
                       buttonClickD();//Rotate
                       
                if (FollowCamFlag.val == true){
		offsetTarget = myCameraRig.position - target.position;   
                myFollowCamFlag = true;
                myImage[32].color = new Color(1f, 0.3f, 0.6f);
                } 
                
                
                 }
            }
            if ((Input.GetKey(KeyCode.LeftControl))&&(Input.GetKeyDown(KeyCode.L))&&(myL90rotate == true)){

                //SuperController.LogMessage("ctrl+L");
                if (myRotateFlag == true){
                       buttonClickA();
                       
                if (FollowCamFlag.val == true){
		offsetTarget = myCameraRig.position - target.position;   
                myFollowCamFlag = true;
                myImage[32].color = new Color(1f, 0.3f, 0.6f);
                } 
                
                
                 }else{
                       buttonClickG();
                       
                if (FollowCamFlag.val == true){
		offsetTarget = myCameraRig.position - target.position;   
                myFollowCamFlag = true;
                myImage[32].color = new Color(1f, 0.3f, 0.6f);
                } 
                       
                 }
            }
            if ((Input.GetKey(KeyCode.LeftControl))&&((Input.GetKeyDown(KeyCode.Return))||(Input.GetKeyDown(KeyCode.KeypadEnter)))&&(myScreenToggle == true)){

                //SuperController.LogMessage("ctrl+Enter");
                 ScreenToggleChange();
            }
            
            

            //FOV slider update
            if (jsonFloat_FOV.val != sc.monitorCameraFOVSlider.value)

            {
                jsonFloat_FOV.val = sc.monitorCameraFOVSlider.value;
                sliderValue1 = jsonFloat_FOV.val;
            }


            //Window shrink slider update
            if (jsonFloat_WorkWindowSize.val != sliderValue2)
            {
                sliderValue2 = jsonFloat_WorkWindowSize.val; // update our tracking value

            }
            
      
          //Offset rotation slider update////////////////////////////////////////////////////////////////////
          if (jsonFloat_rotationOffset.val != sliderValue3){

                if (myRotateFlag == false){return;}

                sliderValue3 = jsonFloat_rotationOffset.val;
                currentRot = sliderValue3;

                var deltaRot = sliderValue3 - myCameraRigTransform.eulerAngles.z;

               myCameraRigTransform.RotateAround(keepWorld_posi, keepMyFoward, deltaRot);

                 sliderValue3 = jsonFloat_rotationOffset.val;
          }
 
 
           //OrbitRotate SPEED slider update
            if (jsonFloat_orbitSpeed.val != sliderValue4)
            {
                sliderValue4 = jsonFloat_orbitSpeed.val; //

            }
          
          
/////////////////////////////////////////////////////////////////////



 


}
////////////////////////////////////////////////////////////////////////////////////////////////////////


}



////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
public class ClickListener : MonoBehaviour, IPointerClickHandler, IPointerEnterHandler, IPointerExitHandler,IPointerDownHandler
    {
        public readonly UnityEvent onPointerClick = new UnityEvent();
        public readonly UnityEvent onPointerRightClick = new UnityEvent();
        public readonly UnityEvent onPointerEnter = new UnityEvent();
        public readonly UnityEvent onPointerExit = new UnityEvent();
        public readonly UnityEvent onPointerDown = new UnityEvent();
        public readonly UnityEvent onPointerRightDown = new UnityEvent();

        public void OnPointerEnter(PointerEventData eventData)
        {
        onPointerEnter.Invoke();
        }
        
        public void OnPointerExit(PointerEventData eventData)
        {
        onPointerExit.Invoke();
        }
        
       public void OnPointerDown(PointerEventData eventData)
        {
                          if ( eventData.button == PointerEventData.InputButton.Right )

                          {
                            //SuperController.LogMessage("RightClick");
                            onPointerRightDown.Invoke();
                          }else{
                            onPointerDown.Invoke();
                          }
         }

        public void OnPointerClick(PointerEventData eventData)
        {

                if ( eventData.button == PointerEventData.InputButton.Left )
                {
                      onPointerClick.Invoke(); 
                }else{
                      onPointerRightClick.Invoke(); 
                }
    
       }
       
   } 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  



}


